/*
-------------------------------------------------------------------------------------------
-- Copyright © 2011-2014, QDESYS
-- This file contains confidential and proprietary information of QDESYS and is
-- protected under European and international copyright and other intellectual property laws.
-------------------------------------------------------------------------------------------
--
-- Disclaimer:
-- This disclaimer is not a license and does not grant any rights to the materials
-- distributed herewith. Except as otherwise provided in a valid license issued to
-- you by QDESYS, and to the maximum extent permitted by applicable law: (1) THESE
-- MATERIALS ARE MADE AVAILABLE "AS IS" AND WITH ALL FAULTS, AND QDESYS HEREBY
-- DISCLAIMS ALL WARRANTIES AND CONDITIONS, EXPRESS, IMPLIED, OR STATUTORY,
-- INCLUDING BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, NON-INFRINGEMENT,
-- OR FITNESS FOR ANY PARTICULAR PURPOSE; and (2) QDESYS shall not be liable
-- (whether in contract or tort, including negligence, or under any other theory
-- of liability) for any loss or damage of any kind or nature related to, arising
-- under or in connection with these materials, including for any direct, or any
-- indirect, special, incidental, or consequential loss or damage (including loss
-- of data, profits, goodwill, or any type of loss or damage suffered as a result
-- of any action brought by a third party) even if such damage or loss was
-- reasonably foreseeable or QDESYS had been advised of the possibility of the same.
--
-- CRITICAL APPLICATIONS
-- QDESYS products are not designed or intended to be fail-safe, or for use in any
-- application requiring fail-safe performance, such as life-support or safety
-- devices or systems, Class III medical devices, nuclear facilities, applications
-- related to the deployment of airbags, or any other applications that could lead
-- to death, personal injury, or severe property or environmental damage
-- (individually and collectively, "Critical Applications"). Customer assumes the
-- sole risk and liability of any use of QDESYS products in Critical Applications,
-- subject only to applicable laws and regulations governing limitations on product
-- liability.
--
-- THIS COPYRIGHT NOTICE AND DISCLAIMER MUST BE RETAINED AS PART OF THIS FILE AT ALL TIMES.
--
--QDESYS
--Via Mazzano 14/a
-- 37024 Negrar Verona Italy
--
-- info@qdesys.com
--
*/

#ifndef DS1820_LX_H
#define DS1820_LX_H

// register offsets

#define DS1820_RA_ip_ident_OFFSET       0
#define DS1820_RA_status_reg_OFFSET     4
#define DS1820_RA_control_reg_OFFSET    8

// IP ident code
#define DS1820_ip_ident_code_value   101


// Status register
#define DS1820_DEF_STATUS_REG_XINIT    0
#define DS1820_DEF_STATUS_REG_XIOBIT   1
#define DS1820_DEF_STATUS_REG_WDATA    2
#define DS1820_DEF_STATUS_REG_RDATA    3
#define DS1820_DEF_STATUS_REG_DONE     4
#define DS1820_DEF_STATUS_REG_BUSY     5

// Control register
#define DS1820_DEF_CONTROL_REG_XINIT   0
#define DS1820_DEF_CONTROL_REG_XIOBIT  1
#define DS1820_DEF_CONTROL_REG_WDATA   2

// ----------------------------------------------------------------------------------

#define DS1820_SEARCH_ROM  0xF0
#define DS1820_MATCH_ROM   0x55
#define DS1820_SKIP_ROM    0xCC

#define DS1820_CONVERT_T   0x44
#define DS1820_READ        0xBE

#define DS1820_FAMILY_CODE_DS1820 0x10

#define DS1820_IDENT_SIZE 8
#define DS1820_SCRPD_SIZE 9

// DS18S20 750 ms max
// DS1820  200 ms typ, 500 max
#define DS1820_TCONV_MAX_MS 800

#endif /** DS1820_LX_H */
