/*
-------------------------------------------------------------------------------------------
-- Copyright  2011-2015, QDESYS
-- This file contains confidential and proprietary information of QDESYS and is
-- protected under European and international copyright and other intellectual property laws.
-------------------------------------------------------------------------------------------
--
-- Disclaimer:
-- This disclaimer is not a license and does not grant any rights to the materials
-- distributed herewith. Except as otherwise provided in a valid license issued to
-- you by QDESYS, and to the maximum extent permitted by applicable law: (1) THESE
-- MATERIALS ARE MADE AVAILABLE "AS IS" AND WITH ALL FAULTS, AND QDESYS HEREBY
-- DISCLAIMS ALL WARRANTIES AND CONDITIONS, EXPRESS, IMPLIED, OR STATUTORY,
-- INCLUDING BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, NON-INFRINGEMENT,
-- OR FITNESS FOR ANY PARTICULAR PURPOSE; and (2) QDESYS shall not be liable
-- (whether in contract or tort, including negligence, or under any other theory
-- of liability) for any loss or damage of any kind or nature related to, arising
-- under or in connection with these materials, including for any direct, or any
-- indirect, special, incidental, or consequential loss or damage (including loss
-- of data, profits, goodwill, or any type of loss or damage suffered as a result
-- of any action brought by a third party) even if such damage or loss was
-- reasonably foreseeable or QDESYS had been advised of the possibility of the same.
--
-- CRITICAL APPLICATIONS
-- QDESYS products are not designed or intended to be fail-safe, or for use in any
-- application requiring fail-safe performance, such as life-support or safety
-- devices or systems, Class III medical devices, nuclear facilities, applications
-- related to the deployment of airbags, or any other applications that could lead
-- to death, personal injury, or severe property or environmental damage
-- (individually and collectively, "Critical Applications"). Customer assumes the
-- sole risk and liability of any use of QDESYS products in Critical Applications,
-- subject only to applicable laws and regulations governing limitations on product
-- liability.
--
-- THIS COPYRIGHT NOTICE AND DISCLAIMER MUST BE RETAINED AS PART OF THIS FILE AT ALL TIMES.
--
--QDESYS
--Via Mazzano 14/a
-- 37024 Negrar Verona Italy
--
-- info@qdesys.com
--
*/

/// \brief fmcmc1_drv ap lib
/// \file fmcmc1_drv_apc.h
/// \version 0.51
/// \date jun 15, 2013
/// \author Diego Quagreda
/// \author CopyRight (c) QDESYS 2009-2013

#ifndef FMCMC1_DRV_APC_H_
#define FMCMC1_DRV_APC_H_

int fmcmc1_drv_ap_compile(fmcmc1_drv *InstancePtr);

int fmcmc1_drv_xadc_reset(fmcmc1_drv *InstancePtr);

int fmcmc1_drv_xadc_reg_io(fmcmc1_drv *InstancePtr, const u8 addr, u16 *rval, const u16 wval, const u8 write);

// SSR SD/XADC
enum {
	FMCMC1_DRV_AP_MASK_SSR_VBUS_0 = 0x01,
	FMCMC1_DRV_AP_MASK_SSR_IABS_0 = 0x02,
	FMCMC1_DRV_AP_MASK_SSR_VBUS_1 = 0x04,
	FMCMC1_DRV_AP_MASK_SSR_IABS_1 = 0x08 };
	
int fmcmc1_drv_xadc_ssr_io(fmcmc1_drv *InstancePtr, u8 *rval, const u8 wval, const u8 write);

int fmcmc1_drv_ap_get_control(fmcmc1_drv *InstancePtr);
int fmcmc1_drv_ap_set_control(fmcmc1_drv *InstancePtr);

int fmcmc1_drv_ap_get_status(fmcmc1_drv *InstancePtr);

int fmcmc1_drv_ap_get_xadc(fmcmc1_drv *InstancePtr);
int fmcmc1_drv_ap_set_xadc(fmcmc1_drv *InstancePtr);

int fmcmc1_drv_ap_get_oc_temp(fmcmc1_drv *InstancePtr, float * oc_temp);

int fmcmc1_drv_ap_init(fmcmc1_drv *InstancePtr);

#endif /* FMCMC1_DRV_APC_H_ */
