/*
-------------------------------------------------------------------------------------------
-- Copyright  2011-2017, QDESYS
-- This file contains confidential and proprietary information of QDESYS and is
-- protected under European and international copyright and other intellectual property laws.
-------------------------------------------------------------------------------------------
--
-- Disclaimer:
-- This disclaimer is not a license and does not grant any rights to the materials
-- distributed herewith. Except as otherwise provided in a valid license issued to
-- you by QDESYS, and to the maximum extent permitted by applicable law: (1) THESE
-- MATERIALS ARE MADE AVAILABLE "AS IS" AND WITH ALL FAULTS, AND QDESYS HEREBY
-- DISCLAIMS ALL WARRANTIES AND CONDITIONS, EXPRESS, IMPLIED, OR STATUTORY,
-- INCLUDING BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, NON-INFRINGEMENT,
-- OR FITNESS FOR ANY PARTICULAR PURPOSE; and (2) QDESYS shall not be liable
-- (whether in contract or tort, including negligence, or under any other theory
-- of liability) for any loss or damage of any kind or nature related to, arising
-- under or in connection with these materials, including for any direct, or any
-- indirect, special, incidental, or consequential loss or damage (including loss
-- of data, profits, goodwill, or any type of loss or damage suffered as a result
-- of any action brought by a third party) even if such damage or loss was
-- reasonably foreseeable or QDESYS had been advised of the possibility of the same.
--
-- CRITICAL APPLICATIONS
-- QDESYS products are not designed or intended to be fail-safe, or for use in any
-- application requiring fail-safe performance, such as life-support or safety
-- devices or systems, Class III medical devices, nuclear facilities, applications
-- related to the deployment of airbags, or any other applications that could lead
-- to death, personal injury, or severe property or environmental damage
-- (individually and collectively, "Critical Applications"). Customer assumes the
-- sole risk and liability of any use of QDESYS products in Critical Applications,
-- subject only to applicable laws and regulations governing limitations on product
-- liability.
--
-- THIS COPYRIGHT NOTICE AND DISCLAIMER MUST BE RETAINED AS PART OF THIS FILE AT ALL TIMES.
-- 
--QDESYS 
--Via Mazzano 14/a
-- 37024 Negrar Verona Italy
--
-- info@qdesys.com
--
*/


#ifndef FMCMC1_DRV_LX_H
#define FMCMC1_DRV_LX_H

// register offsets

#define FMCMC1_DRV_RA_ip_ident_OFFSET          (4*0)
#define FMCMC1_DRV_RA_status_reg_OFFSET        (4*1)

#define FMCMC1_DRV_RA_sd_ctrl_0_OFFSET         (4*2)
#define FMCMC1_DRV_RA_sd_ctrl_1_OFFSET         (4*3)

#define FMCMC1_DRV_RA_oc_temp_val_OFFSET       (4*4)
#define FMCMC1_DRV_RA_oc_temp_fkt_OFFSET       (4*5)

#define FMCMC1_DRV_RA_xa_synclkdiv_OFFSET      (4*6)

#define FMCMC1_DRV_RA_xadc_wctreg_OFFSET       (4*7)
#define FMCMC1_DRV_RA_xadc_rctreg_OFFSET       (4*8)

#define FMCMC1_DRV_RA_dip_sw_OFFSET            (4*9)

#define FMCMC1_DRV_RA_gpio_i_OFFSET            (4*10)
#define FMCMC1_DRV_RA_gpio_o_OFFSET            (4*11)
#define FMCMC1_DRV_RA_gpio_t_OFFSET            (4*12)


// IP ident code
#define FMCMC1_DRV_ip_ident_code_value   7


// Motor status register

// M0
#define FMCMC1_DRV_STATUS_REG_DRV_FAULT_0  (1 << 0)
#define FMCMC1_DRV_STATUS_REG_DRV_OTW_0    (1 << 1)

// M1
#define FMCMC1_DRV_STATUS_REG_DRV_FAULT_1  (1 << 2)
#define FMCMC1_DRV_STATUS_REG_DRV_OTW_1    (1 << 3)



// XADC Control Regiser
#define FMCMC1_DRV_WCTREG_DATA_LO   (1 <<  0)
#define FMCMC1_DRV_WCTREG_DATA_HI   (1 << 15)
#define FMCMC1_DRV_WCTREG_ADDR_LO   (1 << 16)
#define FMCMC1_DRV_WCTREG_ADDR_HI   (1 << 22)
#define FMCMC1_DRV_WCTREG_DRP_EN    (1 << 23)
#define FMCMC1_DRV_WCTREG_DRP_WE    (1 << 24)
#define FMCMC1_DRV_WCTREG_DRP_DC    (1 << 25)
#define FMCMC1_DRV_WCTREG_SYNC      (1 << 26)
#define FMCMC1_DRV_WCTREG_XA_RESET  (1 << 27)
#define FMCMC1_DRV_WCTREG_XA_VBUS_0 (1 << 28)
#define FMCMC1_DRV_WCTREG_XA_IABS_0 (1 << 29)
#define FMCMC1_DRV_WCTREG_XA_VBUS_1 (1 << 30)
#define FMCMC1_DRV_WCTREG_XA_IABS_1 (1 << 31)

// Signal Delta SINC3 filter control registers
#define FMCMC1_DRV_C_SYNCMD_BITOFS   0
#define FMCMC1_DRV_C_SYNTOS_BITOFS   1
#define FMCMC1_DRV_C_DECLIM_BITOFS   7
#define FMCMC1_DRV_C_SKEWMS_BITOFS   13

#define FMCMC1_DRV_C_SYNCMD_BITSIZ   1
#define FMCMC1_DRV_C_SYNTOS_BITSIZ   6
#define FMCMC1_DRV_C_DECLIM_BITSIZ   6
#define FMCMC1_DRV_C_SKEWMS_BITSIZ   6

// ----------------------------------------------------------------------------------

// sd sinc3 filter extra defines
#define FMCMC1_DRV_C_SYNTOS_MAXVAL (1 << FMCMC1_DRV_C_SYNTOS_BITSIZ)
#define FMCMC1_DRV_C_DECLIM_MAXVAL (1 << FMCMC1_DRV_C_DECLIM_BITSIZ)
#define FMCMC1_DRV_C_SKEWMS_MAXVAL (1 << FMCMC1_DRV_C_SKEWMS_BITSIZ)

 // S/D acquisition clock
#define FMCMC1_DRV_SD_CLOCK_FREQ   10000000

// absolute min/max value
#define FMCMC1_DRV_SD_C_CLK_MIN   10
#define FMCMC1_DRV_SD_C_CLK_MAX   FMCMC1_DRV_C_DECLIM_MAXVAL

#define FMCMC1_DRV_SD_S3_IABT_GAIN_MAX  (1 << (FMCMC1_DRV_C_DECLIM_BITSIZ * 2))

#define FMCMC1_DRV_SD_CTRL_DEFAULT (((64-1) << FMCMC1_DRV_C_DECLIM_BITOFS) | ((32-1) << FMCMC1_DRV_C_SKEWMS_BITOFS))

// ----------------------------------------------------------------------------------

// XADC sync current generator
#define FMCMC1_DRV_XA_SYNCLKDIV_DEF (320 - 1)
#define FMCMC1_DRV_XA_SYNCLKDIV_MIN (50-1)
#define FMCMC1_DRV_XA_SYNCLKDIV_MAX ((1 << 10) - 1)

// XADC register definition
#define FMCMC1_DRV_XADC_INIT_48_ON_CHIP_TEMP_BIT   8
#define FMCMC1_DRV_XADC_INIT_49_AUX_0_8_BIT        0
#define FMCMC1_DRV_XADC_INIT_49_AUX_1_9_BIT        1
#define FMCMC1_DRV_XADC_INIT_49_AUX_2_10_BIT       2
#define FMCMC1_DRV_XADC_INIT_49_AUX_3_11_BIT       3

#define FMCMC1_DRV_XADC_KELVIN_ZERO_CENT (273.15)
#define FMCMC1_DRV_XADC_TEMP_KONST       (503.975)

// XADC initialization registers
#define FMCMC1_DRV_XADC_INIT_42_CD_OFFSET_BIT  8
#define FMCMC1_DRV_XADC_INIT_42_CD_SIZE_BIT    8

// XADC init reg.
#define FMCMC1_DRV_XADC_INIT_41_SEQ_OFFSET_BIT  12
#define FMCMC1_DRV_XADC_INIT_41_SEQ_SIZE_BIT     4

// XADC conversion time per channel
#define FMCMC1_DRV_XADC_CONVTIME_ACQ_ZERO   26
#define FMCMC1_DRV_XADC_CONVTIME_ACQ_ONE    32

// ===========================================================================

// Dead time
#define FMCMC1_DRV_DEF_DEADTIME   (5.5e-9)
#define FMCMC1_DRV_MIN_DEADTIME   (5.5e-9)
#define FMCMC1_DRV_MAX_DEADTIME   (5.5e-9)

// ===========================================================================

// S/D analogue conversion
#define FMCMC1_DRV_SD_VBUS_GAIN    (450.6e-6)
#define FMCMC1_DRV_SD_IPHS_GAIN    (37.4e-6)

// ===========================================================================

// XA analogue conversion
#define FMCMC1_DRV_XA_VBUS_GAIN    (10.0e3 + 210.0) / 210.0 / (double)(1 << 17)
#define FMCMC1_DRV_XA_IPHS_GAIN    (1.0 / 0.604 / 20.0 / 0.01) / (double)(1 << 18)

// ===========================================================================

// current limit
#define FMCMC1_DRV_DEF_CURR_LIMIT  (3.1)

#endif /** FMCMC1_DRV_LX_H */
