/*
-------------------------------------------------------------------------------------------
-- Copyright © 2011-2017, QDESYS
-- This file contains confidential and proprietary information of QDESYS and is
-- protected under European and international copyright and other intellectual property laws.
-------------------------------------------------------------------------------------------
--
-- Disclaimer:
-- This disclaimer is not a license and does not grant any rights to the materials
-- distributed herewith. Except as otherwise provided in a valid license issued to
-- you by QDESYS, and to the maximum extent permitted by applicable law: (1) THESE
-- MATERIALS ARE MADE AVAILABLE "AS IS" AND WITH ALL FAULTS, AND QDESYS HEREBY
-- DISCLAIMS ALL WARRANTIES AND CONDITIONS, EXPRESS, IMPLIED, OR STATUTORY,
-- INCLUDING BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, NON-INFRINGEMENT,
-- OR FITNESS FOR ANY PARTICULAR PURPOSE; and (2) QDESYS shall not be liable
-- (whether in contract or tort, including negligence, or under any other theory
-- of liability) for any loss or damage of any kind or nature related to, arising
-- under or in connection with these materials, including for any direct, or any
-- indirect, special, incidental, or consequential loss or damage (including loss
-- of data, profits, goodwill, or any type of loss or damage suffered as a result
-- of any action brought by a third party) even if such damage or loss was
-- reasonably foreseeable or QDESYS had been advised of the possibility of the same.
--
-- CRITICAL APPLICATIONS
-- QDESYS products are not designed or intended to be fail-safe, or for use in any
-- application requiring fail-safe performance, such as life-support or safety
-- devices or systems, Class III medical devices, nuclear facilities, applications
-- related to the deployment of airbags, or any other applications that could lead
-- to death, personal injury, or severe property or environmental damage
-- (individually and collectively, "Critical Applications"). Customer assumes the
-- sole risk and liability of any use of QDESYS products in Critical Applications,
-- subject only to applicable laws and regulations governing limitations on product
-- liability.
--
-- THIS COPYRIGHT NOTICE AND DISCLAIMER MUST BE RETAINED AS PART OF THIS FILE AT ALL TIMES.
-- 
--QDESYS 
--Via Mazzano 14/a
-- 37024 Negrar Verona Italy
--
-- info@qdesys.com
--
*/

#ifndef IVPLOGGER_LX_H
#define IVPLOGGER_LX_H

// register offsets

#define IVPLOGGER_RA_ip_ident_OFFSET   (4*0)
#define IVPLOGGER_RA_acq_ctrlst_OFFSET (4*1)
#define IVPLOGGER_RA_mem_base_OFFSET   (4*2)
#define IVPLOGGER_RA_mem_size_OFFSET   (4*3)
#define IVPLOGGER_RA_acq_level_OFFSET  (4*4)

// IP ident code
#define IVPLOGGER_ip_ident_code_value   103

// ===========================================================================

// -- Record fields mask
	
#define IVPLOGGER_RFLD_IPHS_A    0
#define IVPLOGGER_RFLD_IPHS_B    1
#define IVPLOGGER_RFLD_IPHS_C    2
#define IVPLOGGER_RFLD_IBUS_X    3
#define IVPLOGGER_RFLD_VPHS_A    4
#define IVPLOGGER_RFLD_VPHS_B    5
#define IVPLOGGER_RFLD_VPHS_C    6
#define IVPLOGGER_RFLD_VBUS_X    7
#define IVPLOGGER_RFLD_VPHS_N    8
#define IVPLOGGER_RFLD_ANGLE     9
#define IVPLOGGER_RFLD_MAX       10

// ===========================================================================

#define IVPLOGGER_ACQ_CTRLST_START   (1 << 3) // write only
#define IVPLOGGER_ACQ_CTRLST_READY   (1 << 3) // read only
#define IVPLOGGER_ACQ_CTRLST_W4TRG   (1 << 2) // read only
#define IVPLOGGER_ACQ_CTRLST_SYNMOD1 (1 << 1) // r/w
#define IVPLOGGER_ACQ_CTRLST_SYNMOD0 (1 << 0) // r/w

// ===========================================================================

// IVPL sync mode
#define IVPLOGGER_SYN_AUTO          (                           0 |                            0)
#define IVPLOGGER_SYN_AROT          (                           0 | IVPLOGGER_ACQ_CTRLST_SYNMOD0)

#define IVPLOGGER_REC_FIELD_SIZE    (16)

#define IVPLOGGER_MULT_ANGLE        (1 << (32-16))
#define IVPLOGGER_MULT_CURR         (1 << 2)
#define IVPLOGGER_MULT_VOLT         (1 << 2)

#define IVPLOGGER_OFFSET_ARM        (2147483647)

#endif // IVPLOGGER_LX_H
