/*
-------------------------------------------------------------------------------------------
-- Copyright © 2011-2016, QDESYS
-- This file contains confidential and proprietary information of QDESYS and is
-- protected under European and international copyright and other intellectual property laws.
-------------------------------------------------------------------------------------------
--
-- Disclaimer:
-- This disclaimer is not a license and does not grant any rights to the materials
-- distributed herewith. Except as otherwise provided in a valid license issued to
-- you by QDESYS, and to the maximum extent permitted by applicable law: (1) THESE
-- MATERIALS ARE MADE AVAILABLE "AS IS" AND WITH ALL FAULTS, AND QDESYS HEREBY
-- DISCLAIMS ALL WARRANTIES AND CONDITIONS, EXPRESS, IMPLIED, OR STATUTORY,
-- INCLUDING BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, NON-INFRINGEMENT,
-- OR FITNESS FOR ANY PARTICULAR PURPOSE; and (2) QDESYS shall not be liable
-- (whether in contract or tort, including negligence, or under any other theory
-- of liability) for any loss or damage of any kind or nature related to, arising
-- under or in connection with these materials, including for any direct, or any
-- indirect, special, incidental, or consequential loss or damage (including loss
-- of data, profits, goodwill, or any type of loss or damage suffered as a result
-- of any action brought by a third party) even if such damage or loss was
-- reasonably foreseeable or QDESYS had been advised of the possibility of the same.
--
-- CRITICAL APPLICATIONS
-- QDESYS products are not designed or intended to be fail-safe, or for use in any
-- application requiring fail-safe performance, such as life-support or safety
-- devices or systems, Class III medical devices, nuclear facilities, applications
-- related to the deployment of airbags, or any other applications that could lead
-- to death, personal injury, or severe property or environmental damage
-- (individually and collectively, "Critical Applications"). Customer assumes the
-- sole risk and liability of any use of QDESYS products in Critical Applications,
-- subject only to applicable laws and regulations governing limitations on product
-- liability.
--
-- THIS COPYRIGHT NOTICE AND DISCLAIMER MUST BE RETAINED AS PART OF THIS FILE AT ALL TIMES.
-- 
--QDESYS 
--Via Mazzano 14/a
-- 37024 Negrar Verona Italy
--
-- info@qdesys.com
--
*/

#ifndef MOTCON2_DRV_LX_H
#define MOTCON2_DRV_LX_H

// register offsets

#define MOTCON2_DRV_RA_ip_ident_OFFSET        (4*0)
#define MOTCON2_DRV_RA_status_reg_OFFSET      (4*1)
#define MOTCON2_DRV_RA_control_reg_OFFSET     (4*2)
#define MOTCON2_DRV_RA_oc_temp_val_OFFSET     (4*3)
#define MOTCON2_DRV_RA_oc_temp_fkt_OFFSET     (4*4)

// IP ident code
#define MOTCON2_DRV_ip_ident_code_value   9

// Status Register
#define MOTCON2_DRV_DEF_STATUS_REG_OVC_0       (1 << 0)
#define MOTCON2_DRV_DEF_STATUS_REG_OVC_1       (1 << 1)

// Control Register
#define MOTCON2_DRV_DEF_CONTROL_REG_XA_VBUS_0  (1 << 0)
#define MOTCON2_DRV_DEF_CONTROL_REG_XA_IAB_0   (1 << 1)
#define MOTCON2_DRV_DEF_CONTROL_REG_XA_VBUS_1  (1 << 2)
#define MOTCON2_DRV_DEF_CONTROL_REG_XA_IAB_1   (1 << 3)
#define MOTCON2_DRV_DEF_CONTROL_REG_VT_ENABLE  (1 << 4)

// ----------------------------------------------------------------------------------

#define MOTCON2_DRV_XADC_KELVIN_ZERO_CENT (273.15)
#define MOTCON2_DRV_XADC_TEMP_KONST       (503.975)

// XADC conversion time per channel
#define MOTCON2_DRV_XADC_CONVTIME_ACQ_ZERO   26
#define MOTCON2_DRV_XADC_CONVTIME_ACQ_ONE    32

// XADC sample rate in clocks
#define MOTCON2_DRV_XA_SAMPLE_CLOCK (MOTCON2_DRV_XADC_CONVTIME_ACQ_ONE*3+MOTCON2_DRV_XADC_CONVTIME_ACQ_ZERO*1)

// ----------------------------------------------------------------------------------

// Dead time
#define MOTCON2_DRV_DEF_DEADTIME          (200.0e-9)
#define MOTCON2_DRV_MIN_DEADTIME          (100.0e-9)
#define MOTCON2_DRV_MAX_DEADTIME          (500.0e-9)

// S/D analog conversion
#define MOTCON2_DRV_SD_VBUS_GAIN          (5.88e-4)
#define MOTCON2_DRV_SD_CURR_GAIN          (2.65e-4)

// XA analog conversion
#define MOTCON2_DRV_XA_VBUS_GAIN          (6.10e-4)
#define MOTCON2_DRV_XA_CURR_GAIN          (2.65e-4)

// current limit
#define MOTCON2_DRV_DEF_CURR_LIMIT        (10.1)

#endif /* MOTCON2_DRV_LX_H */
