/*
-------------------------------------------------------------------------------------------
-- Copyright  2011-2018, QDESYS
-- This file contains confidential and proprietary information of QDESYS and is
-- protected under European and international copyright and other intellectual property laws.
-------------------------------------------------------------------------------------------
--
-- Disclaimer:
-- This disclaimer is not a license and does not grant any rights to the materials
-- distributed herewith. Except as otherwise provided in a valid license issued to
-- you by QDESYS, and to the maximum extent permitted by applicable law: (1) THESE
-- MATERIALS ARE MADE AVAILABLE "AS IS" AND WITH ALL FAULTS, AND QDESYS HEREBY
-- DISCLAIMS ALL WARRANTIES AND CONDITIONS, EXPRESS, IMPLIED, OR STATUTORY,
-- INCLUDING BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, NON-INFRINGEMENT,
-- OR FITNESS FOR ANY PARTICULAR PURPOSE; and (2) QDESYS shall not be liable
-- (whether in contract or tort, including negligence, or under any other theory
-- of liability) for any loss or damage of any kind or nature related to, arising
-- under or in connection with these materials, including for any direct, or any
-- indirect, special, incidental, or consequential loss or damage (including loss
-- of data, profits, goodwill, or any type of loss or damage suffered as a result
-- of any action brought by a third party) even if such damage or loss was
-- reasonably foreseeable or QDESYS had been advised of the possibility of the same.
--
-- CRITICAL APPLICATIONS
-- QDESYS products are not designed or intended to be fail-safe, or for use in any
-- application requiring fail-safe performance, such as life-support or safety
-- devices or systems, Class III medical devices, nuclear facilities, applications
-- related to the deployment of airbags, or any other applications that could lead
-- to death, personal injury, or severe property or environmental damage
-- (individually and collectively, "Critical Applications"). Customer assumes the
-- sole risk and liability of any use of QDESYS products in Critical Applications,
-- subject only to applicable laws and regulations governing limitations on product
-- liability.
--
-- THIS COPYRIGHT NOTICE AND DISCLAIMER MUST BE RETAINED AS PART OF THIS FILE AT ALL TIMES.
-- 
--QDESYS 
--Via Mazzano 14/a
-- 37024 Negrar Verona Italy
--
-- info@qdesys.com
--
*/


#ifndef MOTORFOC_LX_H
#define MOTORFOC_LX_H

// register offsets

#define MOTORFOC_RA_ip_ident_OFFSET     (4*0)

#define MOTORFOC_RA_tsclocks_OFFSET     (4*1)

#define MOTORFOC_RA_motcontrol_OFFSET   (4*2)
#define MOTORFOC_RA_motstatus_OFFSET    (4*3)

#define MOTORFOC_RA_val_iphs_a_OFFSET   (4*4)
#define MOTORFOC_RA_val_iphs_b_OFFSET   (4*5)
#define MOTORFOC_RA_val_iphs_c_OFFSET   (4*6)
#define MOTORFOC_RA_val_ibus_x_OFFSET   (4*7)
#define MOTORFOC_RA_val_vphs_a_OFFSET   (4*8)
#define MOTORFOC_RA_val_vphs_b_OFFSET   (4*9)
#define MOTORFOC_RA_val_vphs_c_OFFSET   (4*10)
#define MOTORFOC_RA_val_vbus_x_OFFSET   (4*11)
#define MOTORFOC_RA_val_vphs_n_OFFSET   (4*12)

#define MOTORFOC_RA_ofs_iphs_a_OFFSET   (4*13)
#define MOTORFOC_RA_ofs_iphs_b_OFFSET   (4*14)
#define MOTORFOC_RA_ofs_iphs_c_OFFSET   (4*15)
#define MOTORFOC_RA_ofs_ibus_x_OFFSET   (4*16)
#define MOTORFOC_RA_ofs_vphs_a_OFFSET   (4*17)
#define MOTORFOC_RA_ofs_vphs_b_OFFSET   (4*18)
#define MOTORFOC_RA_ofs_vphs_c_OFFSET   (4*19)
#define MOTORFOC_RA_ofs_vbus_x_OFFSET   (4*20)
#define MOTORFOC_RA_ofs_vphs_n_OFFSET   (4*21)

#define MOTORFOC_RA_xbus_fk1_OFFSET     (4*22)
#define MOTORFOC_RA_xbus_fk2_OFFSET     (4*23)

#define MOTORFOC_RA_xphs_fk1_OFFSET     (4*24)
#define MOTORFOC_RA_xphs_fk2_OFFSET     (4*25)

#define MOTORFOC_RA_ibus_limit_OFFSET   (4*26)
#define MOTORFOC_RA_iphs_limit_OFFSET   (4*27)

#define MOTORFOC_RA_ismodmax_OFFSET     (4*28)

#define MOTORFOC_RA_ismodval_OFFSET     (4*29)
#define MOTORFOC_RA_isangval_OFFSET     (4*30)

#define MOTORFOC_RA_vsmodval_OFFSET     (4*31)
#define MOTORFOC_RA_vsangval_OFFSET     (4*32)

#define MOTORFOC_RA_rot_angdef_OFFSET   (4*33)
#define MOTORFOC_RA_rot_angle_OFFSET    (4*34)

#define MOTORFOC_RA_spd_fktau1_OFFSET   (4*35)
#define MOTORFOC_RA_spd_fktau2_OFFSET   (4*36)
#define MOTORFOC_RA_spd_speed_OFFSET    (4*37)

#define MOTORFOC_RA_smo_vs_mult_OFFSET  (4*38)
#define MOTORFOC_RA_smo_is_mult_OFFSET  (4*39)
#define MOTORFOC_RA_smo_zs_max_OFFSET   (4*40)
#define MOTORFOC_RA_smo_es1_kflt_OFFSET (4*41)
#define MOTORFOC_RA_smo_es2_kflo_OFFSET (4*42)
#define MOTORFOC_RA_smo_es2_kfmx_OFFSET (4*43)
#define MOTORFOC_RA_smo_es2_kflt_OFFSET (4*44)
#define MOTORFOC_RA_smo_angofs_OFFSET   (4*45)
#define MOTORFOC_RA_smo_bemf_p_OFFSET   (4*46)
#define MOTORFOC_RA_smo_bemf_m_OFFSET   (4*47)
#define MOTORFOC_RA_smo_angle_OFFSET    (4*48)

#define MOTORFOC_RA_pos_position_OFFSET (4*49)

#define MOTORFOC_RA_slp_spdset_OFFSET   (4*50)
#define MOTORFOC_RA_slp_kmpro_OFFSET    (4*51)
#define MOTORFOC_RA_slp_kmint_OFFSET    (4*52)
#define MOTORFOC_RA_slp_outlim_OFFSET   (4*53)
#define MOTORFOC_RA_slp_kmultx_OFFSET   (4*54)
#define MOTORFOC_RA_slp_kmulty_OFFSET   (4*55)

#define MOTORFOC_RA_paipol_OFFSET       (4*56)

#define MOTORFOC_RA_ext_angle_OFFSET    (4*57)

#define MOTORFOC_RA_rsv_m2rppk_OFFSET   (4*58)
#define MOTORFOC_RA_rsv_angofs_OFFSET   (4*59)
#define MOTORFOC_RA_rsv_angle_OFFSET    (4*60)

#define MOTORFOC_RA_hls_ctolim_OFFSET   (4*61)
#define MOTORFOC_RA_hls_angle_OFFSET    (4*62)

#define MOTORFOC_RA_enc_index_OFFSET    (4*63)
#define MOTORFOC_RA_enc_phase_OFFSET    (4*64)
#define MOTORFOC_RA_enc_phcpt_OFFSET    (4*65)
#define MOTORFOC_RA_enc_cyprnd_OFFSET   (4*66)
#define MOTORFOC_RA_enc_angphs_OFFSET   (4*67)
#define MOTORFOC_RA_enc_angle_OFFSET    (4*68)

#define MOTORFOC_RA_mrt_speed_OFFSET    (4*69)
#define MOTORFOC_RA_mrt_accmax_OFFSET   (4*70)
#define MOTORFOC_RA_mrt_fktau1_OFFSET   (4*71)
#define MOTORFOC_RA_mrt_fktau2_OFFSET   (4*72)
#define MOTORFOC_RA_mrt_spdout_OFFSET   (4*73)
#define MOTORFOC_RA_mrt_angle_OFFSET    (4*74)

#define MOTORFOC_RA_pi_setvalx_OFFSET   (4*75)
#define MOTORFOC_RA_pi_setvaly_OFFSET   (4*76)
#define MOTORFOC_RA_pi_kmpro_OFFSET     (4*77)
#define MOTORFOC_RA_pi_kmint_OFFSET     (4*78)

#define MOTORFOC_RA_mod2angskw_OFFSET   (4*79)

#define MOTORFOC_RA_pwm_kmod_OFFSET     (4*80)
#define MOTORFOC_RA_pwm_presc_OFFSET    (4*81)
#define MOTORFOC_RA_pwm_mdmax_OFFSET    (4*82)
#define MOTORFOC_RA_pwm_mdval_OFFSET    (4*83)
#define MOTORFOC_RA_pwm_ctrl_OFFSET     (4*84)

#define MOTORFOC_RA_rpfm3p_ctrl_OFFSET  (4*85)

#define MOTORFOC_RA_deadtval_OFFSET     (4*86)
#define MOTORFOC_RA_guswcnt_OFFSET      (4*87)

//-

#define MOTORFOC_RA_hall_sensor_angle_lut_OFFSET  (0x02000)
#define MOTORFOC_RA_pwm_modulator_table_OFFSET    (0x08000)


// IP ident code
#define MOTORFOC_ip_ident_code_value 1

// Inverter a/d inputs index
#define MOTORFOC_IVD_IPHS_A   0
#define MOTORFOC_IVD_IPHS_B   1
#define MOTORFOC_IVD_IPHS_C   2
#define MOTORFOC_IVD_IBUS_X   3
#define MOTORFOC_IVD_VPHS_A   4
#define MOTORFOC_IVD_VPHS_B   5
#define MOTORFOC_IVD_VPHS_C   6
#define MOTORFOC_IVD_VBUS_X   7
#define MOTORFOC_IVD_VPHS_N   8
#define MOTORFOC_IVD_NUM      9


// Motor status register

#define MOTORFOC_BS_hwkill      (1 << 16)
#define MOTORFOC_BS_hwfail      (1 << 15)
#define MOTORFOC_BS_ovi_iphs_a  (1 << 14)
#define MOTORFOC_BS_ovi_iphs_b  (1 << 13)
#define MOTORFOC_BS_ovi_iphs_c  (1 << 12)
#define MOTORFOC_BS_ovi_ibus_x  (1 << 11)
#define MOTORFOC_BS_syserr      (1 << 10)
#define MOTORFOC_BS_spare_9     (1 <<  9)
#define MOTORFOC_BS_spare_8     (1 <<  8)
#define MOTORFOC_BS_spare_7     (1 <<  7)
#define MOTORFOC_BS_rpfmzmd1    (1 <<  6)
#define MOTORFOC_BS_rpfmzmd0    (1 <<  5)
#define MOTORFOC_BS_modtype0    (1 <<  4)
#define MOTORFOC_BS_spd_fwdir   (1 <<  3)
#define MOTORFOC_BS_spd_moving  (1 <<  2)
#define MOTORFOC_BS_pwm_mdovf   (1 <<  1)
#define MOTORFOC_BS_ismodover   (1 <<  0)

// Motor control register

#define MOTORFOC_BC_smo_usevsact (1 << 27)
#define MOTORFOC_BC_zerovphsx    (1 << 26)
#define MOTORFOC_BC_zerovbusx    (1 << 25)
#define MOTORFOC_BC_reseterr     (1 << 24)
#define MOTORFOC_BC_zerocurr     (1 << 23)
#define MOTORFOC_BC_slp_mrt2spd  (1 << 22)
#define MOTORFOC_BC_slp_spd2trq  (1 << 21)
#define MOTORFOC_BC_enc_xmcha    (1 << 20)
#define MOTORFOC_BC_enc_xmchb    (1 << 19)
#define MOTORFOC_BC_enc_xmchi    (1 << 18)
#define MOTORFOC_BC_enc_inten    (1 << 17)
#define MOTORFOC_BC_enc_rstang   (1 << 16)

#define MOTORFOC_BC_mrt_rstang   (1 << 14)
#define MOTORFOC_BC_smo_rstang   (1 << 13)
#define MOTORFOC_BC_fbk_angdef   (1 << 12)
#define MOTORFOC_BC_pi_deafmd    (1 << 11)
#define MOTORFOC_BC_is3phases    (1 << 10)

#define MOTORFOC_BC_modlevels0   (1 <<  8)


#define MOTORFOC_BC_rot_select2  (1 <<  6)
#define MOTORFOC_BC_rot_select1  (1 <<  5)
#define MOTORFOC_BC_rot_select0  (1 <<  4)

#define MOTORFOC_BC_modtype0     (1 <<  2)

#define MOTORFOC_BC_coilenab     (1 <<  0)

// pwm control register bits
#define MOTORFOC_PWM_ctrl_cmmofs (1 << 2)
#define MOTORFOC_PWM_ctrl_table  (1 << 0)


// rpfm 3-phase control register masks
#define MOTORFOC_RPFM3P_ctrl_v7h    (1 << 13)
#define MOTORFOC_RPFM3P_ctrl_v07n   (1 << 12)
#define MOTORFOC_RPFM3P_ctrl_mdpr   (1 <<  8)
#define MOTORFOC_RPFM3P_ctrl_mdkd   (1 <<  0)


// code for rotor position mode
#define MOTORFOC_BC_ROT_POS_MODE_MANUAL    (                      0|                      0|                      0)
#define MOTORFOC_BC_ROT_POS_MODE_EMULATOR  (                      0|                      0|MOTORFOC_BC_rot_select0)
#define MOTORFOC_BC_ROT_POS_MODE_ENCODER   (                      0|MOTORFOC_BC_rot_select1|                      0)
#define MOTORFOC_BC_ROT_POS_MODE_EVALUATOR (                      0|MOTORFOC_BC_rot_select1|MOTORFOC_BC_rot_select0)
#define MOTORFOC_BC_ROT_POS_MODE_HALLSNS   (MOTORFOC_BC_rot_select2|                      0|                      0)
#define MOTORFOC_BC_ROT_POS_MODE_RESOLVER  (MOTORFOC_BC_rot_select2|                      0|MOTORFOC_BC_rot_select0)
#define MOTORFOC_BC_ROT_POS_MODE_EXTERNAL  (MOTORFOC_BC_rot_select2|MOTORFOC_BC_rot_select1|                      0)
#define MOTORFOC_BC_ROT_POS_MODE_MASK      (MOTORFOC_BC_rot_select2|MOTORFOC_BC_rot_select1|MOTORFOC_BC_rot_select0)


// motor constant

#define MOTORFOC_PWM_COUNTER_WIDTH 17
#define MOTORFOC_PWM_TBLWAVE_WIDTH 18
#define MOTORFOC_PWM_KMODULS_WIDTH 16

#define MOTORFOC_PWM_COUNTER_MAX ((1 << MOTORFOC_PWM_COUNTER_WIDTH)-2)

// pwm waveforms: # and size
#define MOTORFOC_PWM_WAVES      4
#define MOTORFOC_PWM_WAVE_LEN 256

// pwm kmod eval ln2(divisor)
#define MOTORFOC_PWM_KMOD_DLN2 14

// rpfm minimun pluse width without jitter
#define MOTORFOC_RPFM_MINPWD_UNJITTER 39

// rpfm low speed clock prescaler range
#define MOTORFOC_RPFM3P_ctrl_mdpr_min   1
#define MOTORFOC_RPFM3P_ctrl_mdpr_max  16

// rpfm high speed clock divisor range
#define MOTORFOC_RPFM3P_ctrl_mdkd_min   2
#define MOTORFOC_RPFM3P_ctrl_mdkd_max 256

#define MOTORFOC_RPFM3P_clocks_width_min 30
#define MOTORFOC_RPFM3P_clocks_width_wrn MOTORFOC_RPFM_MINPWD_UNJITTER
#define MOTORFOC_RPFM3P_clocks_width_max (MOTORFOC_RPFM3P_ctrl_mdkd_max * MOTORFOC_RPFM3P_ctrl_mdpr_max)

// manual rot
#define MOTORFOC_mrt_max_spd  2147483647

// hall sensor
#define MOTORFOC_hls_max_ctolim ((1 << 20)-1)

// hall sensor angle lut size
#define MOTORFOC_HLS_DPR_ANGLE_ELEM 16

// 1st winding offset
#define MOTORFOC_HLS_DPR_STEP_1ST 0

// 2nd winding offset
#define MOTORFOC_HLS_DPR_STEP_2ND 8

// hall step ident
#define MOTORFOC_HLS_DPR_STEP_FWD 0
#define MOTORFOC_HLS_DPR_STEP_1   1
#define MOTORFOC_HLS_DPR_STEP_2   2
#define MOTORFOC_HLS_DPR_STEP_3   3
#define MOTORFOC_HLS_DPR_STEP_4   4
#define MOTORFOC_HLS_DPR_STEP_5   5
#define MOTORFOC_HLS_DPR_STEP_6   6
#define MOTORFOC_HLS_DPR_STEP_REV 7

// hall step # to dpr index
#define MOTORFOC_HLS_DPR_STEP(v) (((v)==1)?1:((v)==2)?3:((v)==3)?2:((v)==4)?6:((v)==5)?4:((v)==6)?5:(v))

// smo: zs limit
#define MOTORFOC_SMO_EVAL_ZS_MAX_INT_MAX ((1 << 17)-1)

// Vs position fractional part size
#define MOTORFOC_POSITION_FRAQ_WIDTH 16

// speed loop y/x modulo 100%
#define MOTORFOC_SLP_YX_MODULO (1 << 16)


// AP defs

// motor identification
#define MOTORFOC_AP_MANUFACTURER_LEN 32
#define MOTORFOC_AP_MOTORCODE_LEN    32

// Windings
#define MOTORFOC_AP_WINDINGS_PMSM    0
#define MOTORFOC_AP_WINDINGS_BLDC    1
#define MOTORFOC_AP_WINDINGS_BIPOLAR 2

// Control Mode
#define MOTORFOC_AP_CTRLMODE_TORQUE   0
#define MOTORFOC_AP_CTRLMODE_SPEED    1

// MRT control
#define MOTORFOC_AP_MRT_CTRLS_TOSPEED    0x01

// Rotor Positor mode
#define MOTORFOC_AP_ROTPOSMODE_MANUAL    0
#define MOTORFOC_AP_ROTPOSMODE_EMULATOR  1
#define MOTORFOC_AP_ROTPOSMODE_ENCODER   2
#define MOTORFOC_AP_ROTPOSMODE_EVALUATOR 3
#define MOTORFOC_AP_ROTPOSMODE_HALLSNS   4
#define MOTORFOC_AP_ROTPOSMODE_RESOLVER  5
#define MOTORFOC_AP_ROTPOSMODE_EXTERNAL  6

// modulator selector
#define MOTORFOC_AP_MODULATOR_PWM  0
#define MOTORFOC_AP_MODULATOR_RPFM 1

// pwm controls
#define MOTORFOC_AP_PWM_CTRLS_CMMOFS  0x04
#define MOTORFOC_AP_PWM_CTRLS_TABLE   0x03


// rpfm controls
#define MOTORFOC_AP_RPFM_CTRLS_V7H  0x02
#define MOTORFOC_AP_RPFM_CTRLS_V07N 0x01

// incremental encoder controls
#define MOTORFOC_AP_ENCODER_CTRLS_INTEN 0x08
#define MOTORFOC_AP_ENCODER_CTRLS_XMCHA 0x04
#define MOTORFOC_AP_ENCODER_CTRLS_XMCHB 0x02
#define MOTORFOC_AP_ENCODER_CTRLS_XMCHI 0x01

// SMO control
#define MOTORFOC_AP_SMO_CTRLS_USEVSACT  0x01

// ip drive source
#define MOTORFOC_AP_IPDRVSOURCE_UDPIP 0
#define MOTORFOC_AP_IPDRVSOURCE_LOCAL 1

#endif /** MOTORFOC_LX_H */
