/*
-------------------------------------------------------------------------------------------
-- Copyright  2011-2018, QDESYS
-- This file contains confidential and proprietary information of QDESYS and is
-- protected under European and international copyright and other intellectual property laws.
-------------------------------------------------------------------------------------------
--
-- Disclaimer:
-- This disclaimer is not a license and does not grant any rights to the materials
-- distributed herewith. Except as otherwise provided in a valid license issued to
-- you by QDESYS, and to the maximum extent permitted by applicable law: (1) THESE
-- MATERIALS ARE MADE AVAILABLE "AS IS" AND WITH ALL FAULTS, AND QDESYS HEREBY
-- DISCLAIMS ALL WARRANTIES AND CONDITIONS, EXPRESS, IMPLIED, OR STATUTORY,
-- INCLUDING BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, NON-INFRINGEMENT,
-- OR FITNESS FOR ANY PARTICULAR PURPOSE; and (2) QDESYS shall not be liable
-- (whether in contract or tort, including negligence, or under any other theory
-- of liability) for any loss or damage of any kind or nature related to, arising
-- under or in connection with these materials, including for any direct, or any
-- indirect, special, incidental, or consequential loss or damage (including loss
-- of data, profits, goodwill, or any type of loss or damage suffered as a result
-- of any action brought by a third party) even if such damage or loss was
-- reasonably foreseeable or QDESYS had been advised of the possibility of the same.
--
-- CRITICAL APPLICATIONS
-- QDESYS products are not designed or intended to be fail-safe, or for use in any
-- application requiring fail-safe performance, such as life-support or safety
-- devices or systems, Class III medical devices, nuclear facilities, applications
-- related to the deployment of airbags, or any other applications that could lead
-- to death, personal injury, or severe property or environmental damage
-- (individually and collectively, "Critical Applications"). Customer assumes the
-- sole risk and liability of any use of QDESYS products in Critical Applications,
-- subject only to applicable laws and regulations governing limitations on product
-- liability.
--
-- THIS COPYRIGHT NOTICE AND DISCLAIMER MUST BE RETAINED AS PART OF THIS FILE AT ALL TIMES.
--
--QDESYS
--Via Mazzano 14/a
-- 37024 Negrar Verona Italy
--
-- info@qdesys.com
--
*/

/// \brief motorfoc ap lib
/// \file motorfoc_utl.c
/// \version 0.51
/// \date jun 15, 2013
/// \author Diego Quagreda
/// \author CopyRight (c) QDESYS 2009-2018

#ifndef _MOTORFOC_UTL_H_
#define _MOTORFOC_UTL_H_

int      motorfoc_abs_int(const int v);
int      motorfoc_max_int(const int a, const int b);
int      motorfoc_min_int(const int a, const int b);

int      motorfoc_adjval_s18(const int v);
int      motorfoc_clip_round_int(const float v, const int l, const int h);
int      motorfoc_clip_round_s18(const float v);
uint32_t motorfoc_clip_round_u17(const float v);
uint32_t motorfoc_clip_round_u32(const float v);

float    motorfoc_lpf1_T2Fcut(float Ts, float T);
float    motorfoc_lpf1_Fcut2T(float Ts, float Fcut);
float    motorfoc_lpf1_T2K(float T);
float    motorfoc_lpf1_K2T(float K);
uint32_t motorfoc_lpf1_Fcut2IK(float Ts, float Fcut);
float    motorfoc_lpf1_IK2Fcut(float Ts, uint32_t ik);

#endif /* _MOTORFOC_UTL_H_ */
