/*
-------------------------------------------------------------------------------------------
-- Copyright © 2011-2015, QDESYS
-- This file contains confidential and proprietary information of QDESYS and is
-- protected under European and international copyright and other intellectual property laws.
-------------------------------------------------------------------------------------------
--
-- Disclaimer:
-- This disclaimer is not a license and does not grant any rights to the materials
-- distributed herewith. Except as otherwise provided in a valid license issued to
-- you by QDESYS, and to the maximum extent permitted by applicable law: (1) THESE
-- MATERIALS ARE MADE AVAILABLE "AS IS" AND WITH ALL FAULTS, AND QDESYS HEREBY
-- DISCLAIMS ALL WARRANTIES AND CONDITIONS, EXPRESS, IMPLIED, OR STATUTORY,
-- INCLUDING BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, NON-INFRINGEMENT,
-- OR FITNESS FOR ANY PARTICULAR PURPOSE; and (2) QDESYS shall not be liable
-- (whether in contract or tort, including negligence, or under any other theory
-- of liability) for any loss or damage of any kind or nature related to, arising
-- under or in connection with these materials, including for any direct, or any
-- indirect, special, incidental, or consequential loss or damage (including loss
-- of data, profits, goodwill, or any type of loss or damage suffered as a result
-- of any action brought by a third party) even if such damage or loss was
-- reasonably foreseeable or QDESYS had been advised of the possibility of the same.
--
-- CRITICAL APPLICATIONS
-- QDESYS products are not designed or intended to be fail-safe, or for use in any
-- application requiring fail-safe performance, such as life-support or safety
-- devices or systems, Class III medical devices, nuclear facilities, applications
-- related to the deployment of airbags, or any other applications that could lead
-- to death, personal injury, or severe property or environmental damage
-- (individually and collectively, "Critical Applications"). Customer assumes the
-- sole risk and liability of any use of QDESYS products in Critical Applications,
-- subject only to applicable laws and regulations governing limitations on product
-- liability.
--
-- THIS COPYRIGHT NOTICE AND DISCLAIMER MUST BE RETAINED AS PART OF THIS FILE AT ALL TIMES.
--
--QDESYS
--Via Mazzano 14/a
-- 37024 Negrar Verona Italy
--
-- info@qdesys.com
--
*/

/// \brief netmot_drv  ap lib
/// \file netmot_drv_apc.c
/// \version 0.1
/// \date jan 3, 2015
/// \author Diego Quagreda
/// \author CopyRight (c) QDESYS 2009-2015

//#include <stdio.h>
#include "xparameters.h"
#include "xil_types.h"
#include "xstatus.h"
#include "netmot_drv.h"
#include "netmot_drv_apc.h"

//#include <math.h>

int netmot_drv_ap_fpga_setup_4_program(void)
{
	xil_printf("\r\n\r\nWARNING!!! Remove motor power supply before to program FPGA!!!\r\n");
	u16 id;
	for(id=0;;id++)
	{
		netmot_drv_Config *CfgPtr = netmot_drv_LookupConfig(id);
		if (CfgPtr == NULL)
			break;
		u32 netmot_base = CfgPtr->BaseAddress;
		netmot_drv_fpga_setup_for_program_dev(netmot_base,1);
	}
	return XST_SUCCESS;
}

int netmot_drv_ap_fpga_dna_show(netmot_drv *InstancePtr)
{
	if (InstancePtr == NULL) {
		return XST_FAILURE;
	}
		
	u32 netmot_base = InstancePtr->Config->BaseAddress;

	netmot_fpga_dna_t dna;
	if (netmot_drv_fpga_dna_read(netmot_base, &dna) != XST_SUCCESS)
		return XST_FAILURE;
	xil_printf("DNA: %02X %02X %02X %02X %02X %02X %02X %02X  VER: %02X=%d\r\n",
		dna.dec.dna[0],dna.dec.dna[1],dna.dec.dna[2],dna.dec.dna[3],dna.dec.dna[4],dna.dec.dna[5],dna.dec.dna[6],dna.dec.dna[7],
		dna.dec.ver,dna.dec.ver);
	return XST_SUCCESS;
}

int netmot_drv_ap_init(netmot_drv *InstancePtr)
{
	if (InstancePtr == NULL) {
		return XST_FAILURE;
	}
	return XST_SUCCESS;
}
