/*
-------------------------------------------------------------------------------------------
-- Copyright © 2011-2017, QDESYS
-- This file contains confidential and proprietary information of QDESYS and is
-- protected under European and international copyright and other intellectual property laws.
-------------------------------------------------------------------------------------------
--
-- Disclaimer:
-- This disclaimer is not a license and does not grant any rights to the materials
-- distributed herewith. Except as otherwise provided in a valid license issued to
-- you by QDESYS, and to the maximum extent permitted by applicable law: (1) THESE
-- MATERIALS ARE MADE AVAILABLE "AS IS" AND WITH ALL FAULTS, AND QDESYS HEREBY
-- DISCLAIMS ALL WARRANTIES AND CONDITIONS, EXPRESS, IMPLIED, OR STATUTORY,
-- INCLUDING BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, NON-INFRINGEMENT,
-- OR FITNESS FOR ANY PARTICULAR PURPOSE; and (2) QDESYS shall not be liable
-- (whether in contract or tort, including negligence, or under any other theory
-- of liability) for any loss or damage of any kind or nature related to, arising
-- under or in connection with these materials, including for any direct, or any
-- indirect, special, incidental, or consequential loss or damage (including loss
-- of data, profits, goodwill, or any type of loss or damage suffered as a result
-- of any action brought by a third party) even if such damage or loss was
-- reasonably foreseeable or QDESYS had been advised of the possibility of the same.
--
-- CRITICAL APPLICATIONS
-- QDESYS products are not designed or intended to be fail-safe, or for use in any
-- application requiring fail-safe performance, such as life-support or safety
-- devices or systems, Class III medical devices, nuclear facilities, applications
-- related to the deployment of airbags, or any other applications that could lead
-- to death, personal injury, or severe property or environmental damage
-- (individually and collectively, "Critical Applications"). Customer assumes the
-- sole risk and liability of any use of QDESYS products in Critical Applications,
-- subject only to applicable laws and regulations governing limitations on product
-- liability.
--
-- THIS COPYRIGHT NOTICE AND DISCLAIMER MUST BE RETAINED AS PART OF THIS FILE AT ALL TIMES.
-- 
--QDESYS 
--Via Mazzano 14/a
-- 37024 Negrar Verona Italy
--
-- info@qdesys.com
--
*/

#ifndef TEC53_DRV_LX_H
#define TEC53_DRV_LX_H

// register offsets

#define TEC53_DRV_RA_ip_ident_OFFSET        (4*0)

// ===========================================================================

// IP ident code
#define TEC53_DRV_ip_ident_code_value    14


// ===========================================================================

// Dead time
#define TEC53_DRV_DEF_DEADTIME            (350.0e-9)
#define TEC53_DRV_MIN_DEADTIME            (250.0e-9)
#define TEC53_DRV_MAX_DEADTIME            (600.0e-9)

// ===========================================================================

// S/D v-bus
#define TEC53_DRV_SD_VBUS_GAIN            (1.35e-3)

// S/D i-bus
#define TEC53_DRV_SD_IBUS_GAIN            (7.15e-4)

// S/D v-phase
#define TEC53_DRV_SD_VPHS_GAIN            (1.35e-3)

// S/D i-phase
#define TEC53_DRV_SD_IPHS_GAIN            (7.15e-4)

// current limit                            
#define TEC53_DRV_DEF_IPHS_LIMIT          (80.0)
#define TEC53_DRV_DEF_IBUS_LIMIT          (80.0)

#endif // TEC53_DRV_LX_H
