/*
-------------------------------------------------------------------------------------------
-- Copyright  2011-2016, QDESYS
-- This file contains confidential and proprietary information of QDESYS and is
-- protected under European and international copyright and other intellectual property laws.
-------------------------------------------------------------------------------------------
--
-- Disclaimer:
-- This disclaimer is not a license and does not grant any rights to the materials
-- distributed herewith. Except as otherwise provided in a valid license issued to
-- you by QDESYS, and to the maximum extent permitted by applicable law: (1) THESE
-- MATERIALS ARE MADE AVAILABLE "AS IS" AND WITH ALL FAULTS, AND QDESYS HEREBY
-- DISCLAIMS ALL WARRANTIES AND CONDITIONS, EXPRESS, IMPLIED, OR STATUTORY,
-- INCLUDING BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, NON-INFRINGEMENT,
-- OR FITNESS FOR ANY PARTICULAR PURPOSE; and (2) QDESYS shall not be liable
-- (whether in contract or tort, including negligence, or under any other theory
-- of liability) for any loss or damage of any kind or nature related to, arising
-- under or in connection with these materials, including for any direct, or any
-- indirect, special, incidental, or consequential loss or damage (including loss
-- of data, profits, goodwill, or any type of loss or damage suffered as a result
-- of any action brought by a third party) even if such damage or loss was
-- reasonably foreseeable or QDESYS had been advised of the possibility of the same.
--
-- CRITICAL APPLICATIONS
-- QDESYS products are not designed or intended to be fail-safe, or for use in any
-- application requiring fail-safe performance, such as life-support or safety
-- devices or systems, Class III medical devices, nuclear facilities, applications
-- related to the deployment of airbags, or any other applications that could lead
-- to death, personal injury, or severe property or environmental damage
-- (individually and collectively, "Critical Applications"). Customer assumes the
-- sole risk and liability of any use of QDESYS products in Critical Applications,
-- subject only to applicable laws and regulations governing limitations on product
-- liability.
--
-- THIS COPYRIGHT NOTICE AND DISCLAIMER MUST BE RETAINED AS PART OF THIS FILE AT ALL TIMES.
--
--QDESYS
--Via Mazzano 14/a
-- 37024 Negrar Verona Italy
--
-- info@qdesys.com
--
*/

/// \brief tlimot_drv ap lib
/// \file tlimot_drv_apc.c
/// \version 0.51
/// \date jun 15, 2013
/// \author Diego Quagreda
/// \author CopyRight (c) QDESYS 2009-2013

//#include <stdio.h>
#include "xparameters.h"
#include "xil_types.h"
#include "xstatus.h"

#include "motorfoc_utl.h"

#include "tlimot_drv.h"
#include "tlimot_drv_apc.h"

//#include <math.h>

#define QD_TLIMOT_DRV_DEFLADDR                u32 qd_tlimot_drv_laddr = InstancePtr->Config->BaseAddress;
#define QD_TLIMOT_DRV_REFLADDR                qd_tlimot_drv_laddr

int tlimot_drv_ap_coil_control(tlimot_drv *InstancePtr, const int drive)
{
	if (InstancePtr == NULL) {
		return XST_FAILURE;
	}
		
    // driver base address
	QD_TLIMOT_DRV_DEFLADDR;
	
	TLIMOT_DRV_mWrite_coil_ctrl(QD_TLIMOT_DRV_REFLADDR,drive ? TLIMOT_DRV_COIL_CTRL_GX_AUTO : 0);
	
	return XST_SUCCESS;
}

