/*
-------------------------------------------------------------------------------------------
-- Copyright © 2011-2017, QDESYS
-- This file contains confidential and proprietary information of QDESYS and is
-- protected under European and international copyright and other intellectual property laws.
-------------------------------------------------------------------------------------------
--
-- Disclaimer:
-- This disclaimer is not a license and does not grant any rights to the materials
-- distributed herewith. Except as otherwise provided in a valid license issued to
-- you by QDESYS, and to the maximum extent permitted by applicable law: (1) THESE
-- MATERIALS ARE MADE AVAILABLE "AS IS" AND WITH ALL FAULTS, AND QDESYS HEREBY
-- DISCLAIMS ALL WARRANTIES AND CONDITIONS, EXPRESS, IMPLIED, OR STATUTORY,
-- INCLUDING BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, NON-INFRINGEMENT,
-- OR FITNESS FOR ANY PARTICULAR PURPOSE; and (2) QDESYS shall not be liable
-- (whether in contract or tort, including negligence, or under any other theory
-- of liability) for any loss or damage of any kind or nature related to, arising
-- under or in connection with these materials, including for any direct, or any
-- indirect, special, incidental, or consequential loss or damage (including loss
-- of data, profits, goodwill, or any type of loss or damage suffered as a result
-- of any action brought by a third party) even if such damage or loss was
-- reasonably foreseeable or QDESYS had been advised of the possibility of the same.
--
-- CRITICAL APPLICATIONS
-- QDESYS products are not designed or intended to be fail-safe, or for use in any
-- application requiring fail-safe performance, such as life-support or safety
-- devices or systems, Class III medical devices, nuclear facilities, applications
-- related to the deployment of airbags, or any other applications that could lead
-- to death, personal injury, or severe property or environmental damage
-- (individually and collectively, "Critical Applications"). Customer assumes the
-- sole risk and liability of any use of QDESYS products in Critical Applications,
-- subject only to applicable laws and regulations governing limitations on product
-- liability.
--
-- THIS COPYRIGHT NOTICE AND DISCLAIMER MUST BE RETAINED AS PART OF THIS FILE AT ALL TIMES.
-- 
--QDESYS 
--Via Mazzano 14/a
-- 37024 Negrar Verona Italy
--
-- info@qdesys.com
--
*/

#ifndef TLIMOT_DRV_LX_H
#define TLIMOT_DRV_LX_H

// register offsets

#define TLIMOT_DRV_RA_ip_ident_OFFSET          (4*0)
#define TLIMOT_DRV_RA_status_reg_OFFSET        (4*1)
#define TLIMOT_DRV_RA_control_reg_OFFSET       (4*2)
#define TLIMOT_DRV_RA_coil_ctrl_OFFSET         (4*3)

// IP ident code
#define TLIMOT_DRV_ip_ident_code_value   4

// ===========================================================================

#define TLIMOT_DRV_STATUS_REG_MIDX          (1 << 0)
#define TLIMOT_DRV_STATUS_REG_MCHA          (1 << 1)
#define TLIMOT_DRV_STATUS_REG_MCHB          (1 << 2)

#define TLIMOT_DRV_CONTROL_REG_GUCENA_D1_H  (1 <<  0)
#define TLIMOT_DRV_CONTROL_REG_GUCENA_D1_M  (1 <<  1)
#define TLIMOT_DRV_CONTROL_REG_GUCENA_D1_N  (1 <<  2)
#define TLIMOT_DRV_CONTROL_REG_GUCENA_D1_L  (1 <<  3)
#define TLIMOT_DRV_CONTROL_REG_GUCENA_D2_H  (1 <<  4)
#define TLIMOT_DRV_CONTROL_REG_GUCENA_D2_M  (1 <<  5)
#define TLIMOT_DRV_CONTROL_REG_GUCENA_D2_N  (1 <<  6)
#define TLIMOT_DRV_CONTROL_REG_GUCENA_D2_L  (1 <<  7)
#define TLIMOT_DRV_CONTROL_REG_GUCENA_D3_H  (1 <<  8)
#define TLIMOT_DRV_CONTROL_REG_GUCENA_D3_M  (1 <<  9)
#define TLIMOT_DRV_CONTROL_REG_GUCENA_D3_N  (1 << 10)
#define TLIMOT_DRV_CONTROL_REG_GUCENA_D3_L  (1 << 11)
#define TLIMOT_DRV_CONTROL_REG_ENC_DIFF     (1 << 12)

#define TLIMOT_DRV_COIL_CTRL_D1_H           (1 <<  0)
#define TLIMOT_DRV_COIL_CTRL_D1_M           (1 <<  1)
#define TLIMOT_DRV_COIL_CTRL_D1_N           (1 <<  2)
#define TLIMOT_DRV_COIL_CTRL_D1_L           (1 <<  3)
#define TLIMOT_DRV_COIL_CTRL_D2_H           (1 <<  4)
#define TLIMOT_DRV_COIL_CTRL_D2_M           (1 <<  5)
#define TLIMOT_DRV_COIL_CTRL_D2_N           (1 <<  6)
#define TLIMOT_DRV_COIL_CTRL_D2_L           (1 <<  7)
#define TLIMOT_DRV_COIL_CTRL_D3_H           (1 <<  8)
#define TLIMOT_DRV_COIL_CTRL_D3_M           (1 <<  9)
#define TLIMOT_DRV_COIL_CTRL_D3_N           (1 << 10)
#define TLIMOT_DRV_COIL_CTRL_D3_L           (1 << 11)
#define TLIMOT_DRV_COIL_CTRL_GX_AUTO        (1 << 12)

// ===========================================================================

// Dead time
#define TLIMOT_DRV_DEF_DEADTIME        (100.0e-9)
#define TLIMOT_DRV_MIN_DEADTIME        (80.0e-9)
#define TLIMOT_DRV_MAX_DEADTIME        (200.0e-9)

// ===========================================================================

// S/D analog conversion
#define TLIMOT_DRV_SD_VBUS_GAIN        (3.92e-3)
#define TLIMOT_DRV_SD_IPHS_GAIN        (2.44e-4)

// current limit
#define TLIMOT_DRV_DEF_CURR_LIMIT      (31.1)

#endif // TLIMOT_DRV_LX_H
