/*
-------------------------------------------------------------------------------------------
-- Copyright  2011-2013, QDESYS
-- This file contains confidential and proprietary information of QDESYS and is
-- protected under European and international copyright and other intellectual property laws.
-------------------------------------------------------------------------------------------
--
-- Disclaimer:
-- This disclaimer is not a license and does not grant any rights to the materials
-- distributed herewith. Except as otherwise provided in a valid license issued to
-- you by QDESYS, and to the maximum extent permitted by applicable law: (1) THESE
-- MATERIALS ARE MADE AVAILABLE "AS IS" AND WITH ALL FAULTS, AND QDESYS HEREBY
-- DISCLAIMS ALL WARRANTIES AND CONDITIONS, EXPRESS, IMPLIED, OR STATUTORY,
-- INCLUDING BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, NON-INFRINGEMENT,
-- OR FITNESS FOR ANY PARTICULAR PURPOSE; and (2) QDESYS shall not be liable
-- (whether in contract or tort, including negligence, or under any other theory
-- of liability) for any loss or damage of any kind or nature related to, arising
-- under or in connection with these materials, including for any direct, or any
-- indirect, special, incidental, or consequential loss or damage (including loss
-- of data, profits, goodwill, or any type of loss or damage suffered as a result
-- of any action brought by a third party) even if such damage or loss was
-- reasonably foreseeable or QDESYS had been advised of the possibility of the same.
--
-- CRITICAL APPLICATIONS
-- QDESYS products are not designed or intended to be fail-safe, or for use in any
-- application requiring fail-safe performance, such as life-support or safety
-- devices or systems, Class III medical devices, nuclear facilities, applications
-- related to the deployment of airbags, or any other applications that could lead
-- to death, personal injury, or severe property or environmental damage
-- (individually and collectively, "Critical Applications"). Customer assumes the
-- sole risk and liability of any use of QDESYS products in Critical Applications,
-- subject only to applicable laws and regulations governing limitations on product
-- liability.
--
-- THIS COPYRIGHT NOTICE AND DISCLAIMER MUST BE RETAINED AS PART OF THIS FILE AT ALL TIMES.
-- 
--QDESYS 
--Via Mazzano 14/a
-- 37024 Negrar Verona Italy
--
-- info@qdesys.com
--
*/

#ifndef ZEDODISP_LX_H
#define ZEDODISP_LX_H

// register offsets

#define ZEDODISP_fmem_OFFSET         0x000
#define ZEDODISP_ctrlst_OFFSET       0x200

// frame memory size
#define ZEDODISP_FMEM_SIZE 512

// 128x32
#define ZEDODISP_COLUMNS 128
#define ZEDODISP_PAGES     4

#define ZEDODISP_CTRLST_D0    0
#define ZEDODISP_CTRLST_D7    7
#define ZEDODISP_CTRLST_XREQ  8
#define ZEDODISP_CTRLST_DC    9
#define ZEDODISP_CTRLST_RES  10
#define ZEDODISP_CTRLST_VDD  11
#define ZEDODISP_CTRLST_VBAT 12
#define ZEDODISP_CTRLST_AUTO 13
#define ZEDODISP_CTRLST_XACK 14
#define ZEDODISP_CTRLST_BUSY 15
#define ZEDODISP_CTRLST_R16  16
#define ZEDODISP_CTRLST_R31  31

// display basic/commands

#define ZEDODISP_CMD_DISP_OFF 0xAE
#define ZEDODISP_CMD_DISP_ON  0xAF

#define ZEDODISP_CMD_INIT_BASE    { 0x8D, 0x14, 0xD9, 0xF1 }

#define ZEDODISP_CMD_INIT_SCN_0   { 0xA0, 0xC0, 0xDA, 0x00 }
#define ZEDODISP_CMD_INIT_SCN_180 { 0xA1, 0xC8, 0xDA, 0x20 }

#endif /** ZEDODISP_LX_H */
