/*
-------------------------------------------------------------------------------------------
-- Copyright (c) 2007-2020, QDESYS
-- This file contains confidential and proprietary information of QDESYS and is
-- protected under European and international copyright and other intellectual property laws.
-------------------------------------------------------------------------------------------
--
-- Disclaimer:
-- This disclaimer is not a license and does not grant any rights to the materials
-- distributed herewith. Except as otherwise provided in a valid license issued to
-- you by QDESYS, and to the maximum extent permitted by applicable law: (1) THESE
-- MATERIALS ARE MADE AVAILABLE "AS IS" AND WITH ALL FAULTS, AND QDESYS HEREBY
-- DISCLAIMS ALL WARRANTIES AND CONDITIONS, EXPRESS, IMPLIED, OR STATUTORY,
-- INCLUDING BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, NON-INFRINGEMENT,
-- OR FITNESS FOR ANY PARTICULAR PURPOSE; and (2) QDESYS shall not be liable
-- (whether in contract or tort, including negligence, or under any other theory
-- of liability) for any loss or damage of any kind or nature related to, arising
-- under or in connection with these materials, including for any direct, or any
-- indirect, special, incidental, or consequential loss or damage (including loss
-- of data, profits, goodwill, or any type of loss or damage suffered as a result
-- of any action brought by a third party) even if such damage or loss was
-- reasonably foreseeable or QDESYS had been advised of the possibility of the same.
--
-- CRITICAL APPLICATIONS
-- QDESYS products are not designed or intended to be fail-safe, or for use in any
-- application requiring fail-safe performance, such as life-support or safety
-- devices or systems, Class III medical devices, nuclear facilities, applications
-- related to the deployment of airbags, or any other applications that could lead
-- to death, personal injury, or severe property or environmental damage
-- (individually and collectively, "Critical Applications"). Customer assumes the
-- sole risk and liability of any use of QDESYS products in Critical Applications,
-- subject only to applicable laws and regulations governing limitations on product
-- liability.
--
-- THIS COPYRIGHT NOTICE AND DISCLAIMER MUST BE RETAINED AS PART OF THIS FILE AT ALL TIMES.
--
--QDESYS
--Via Mazzano 14/a
-- 37024 Negrar Verona Italy
--
-- info@qdesys.com
--
*/

/// \brief motor control agent can protocol defines
/// \file mcaxeth.h
/// \version 1.01
/// \date Apr  6, 2018
/// \author Diego Quagreda
/// \author CopyRight (c) QDESYS 2007-2020

#ifndef MCAXETH_H_
#define MCAXETH_H_

// UDP port number
#define XETHCTL_UDP_PORT 9941

// protocol header identification
#define XETHCTL_PROTO_TYPE 23

// protocol header codes
enum
{
	XETHCTL_CODE_cIdent     = 0,
	XETHCTL_CODE_sIdent     = 1,

	XETHCTL_CODE_cCtrl      = 2,
	XETHCTL_CODE_sStat      = 3,

	XETHCTL_CODE_cGetDpr    = 4,
	XETHCTL_CODE_sGetDpr    = 5,

	XETHCTL_CODE_cSetDpr    = 6,
	XETHCTL_CODE_sSetDpr    = 7,

	XETHCTL_CODE_xInvalid   = 11,

	XETHCTL_CODE_cNetSetup  = 12,

	XETHCTL_CODE_cIpsSetup  = 13,
	XETHCTL_CODE_sIpsSetup  = 14,

	XETHCTL_CODE_cTerminate = 15,
	XETHCTL_CODE_cRestart   = 16,

	XETHCTL_CODE_cGetIvpL   = 17,
	XETHCTL_CODE_sGetIvpL   = 18,

	XETHCTL_CODE_cRpcEnvSetup = 19,
	XETHCTL_CODE_sRpcEnvSetup = 20,

	XETHCTL_CODE_cRpcEnvErase = 21,
	XETHCTL_CODE_sRpcEnvErase = 22,

	XETHCTL_CODE_xPadEndCode = 255
};

#define XETHCTL_CARRIER_NAME_LENGTH 32

#endif /* MCAXETH_H_ */
