# This file contains the constraints for the Dyplo IP.

# Create dab_clk and dyplo_clock
create_generated_clock -name dab_clk -divide_by 1 -source [get_ports -regexp .*S_AXI_ACLK] [get_ports -regexp .*S_AXI_ACLK]
create_generated_clock -name dyplo_clk -divide_by 1 -source [get_ports -regexp .*dyplo_clock] [get_ports -regexp .*dyplo_clock]

# Create (generated) user clocks
create_generated_clock -name user_clk_1 -divide_by 2 -source [get_ports -regexp .*dyplo_clock] [get_pins -hier -regexp .*user_clk1.*/Q]
create_generated_clock -name user_clk_2 -divide_by 4 -source [get_ports -regexp .*dyplo_clock] [get_pins -hier -regexp .*user_clk2.*/Q]
create_generated_clock -name user_clk_3 -divide_by 8 -source [get_ports -regexp .*dyplo_clock] [get_pins -hier -regexp .*user_clk3.*/Q]

# Set false paths from dab_clk to other clocks and vice versa
set_false_path -from [get_clocks dab_clk] -to [get_clocks -filter {NAME != dab_clk}]
set_false_path -from [get_clocks -filter {NAME != dab_clk}] -to [get_clocks dab_clk]

# Set false paths from dyplo_clk to other clocks and vice versa
set_false_path -from [get_clocks dyplo_clk] -to [get_clocks -filter {NAME != dyplo_clk}]
set_false_path -from [get_clocks -filter {NAME != dyplo_clk}] -to [get_clocks dyplo_clk]


