ECHO OFF

IF not "%SD_VERSION%"=="y" (
    IF not "%SD_VERSION%"=="n" (
      IF not "%SD_VERSION%"=="d" (
      ECHO ON
      echo SD_version is not set correctly.
      echo for WiFi version: set SD_VERSION=n
      echo for SD version: set SD_VERSION=y
      echo To use the generate_bd.tcl: set SD_VERSION=d
      exit /b 1
)
)
)

del fpga.bit 2>nul

IF "%FPGA_FAMILY%"=="xczu7ev" (
    set PART=%FPGA_FAMILY%-fbvb900-2-i

) ELSE (
    echo "Environment variable FPGA_FAMILY=%FPGA_FAMILY% is not valid, Valid are: xczu7ev"
    exit /b 1
)

cd IP/dyplo
for /r %%i in (*.zip) do powershell -command "expand-archive %%i  -DestinationPath ./ -Force"
cd ../../

cd IP/ip-qdesys
for /r %%i in (*.zip) do powershell -command "expand-archive %%i  -DestinationPath ./ -Force"
cd ../../

cd IP/ip-topic-fanctrl
for /r %%i in (*.zip) do powershell -command "expand-archive %%i -DestinationPath ./ -Force"
cd ../../

set VIVADO_TCL=vivado -nolog -nojournal -mode batch -notrace -source

IF "%SD_VERSION%"=="y" (
    copy generate_bd_sd.tcl generate_bd.tcl
)

IF "%SD_VERSION%"=="n" (
    copy generate_bd_wifi.tcl generate_bd.tcl
)

call %VIVADO_TCL% generate_bitstream.tcl -tclargs %PART%

copy %PART%\%PART%.runs\impl_1\*.bit fpga.bit

if exist fpga.bit (
    exit /b 0
) else (
    exit /b 1
)