#!/bin/sh

rm -f fpga.bit

case "$FPGA_FAMILY" in
	xczu7ev)
		export PART=${FPGA_FAMILY}-fbvb900-2-i
		;;
	*)
		echo "Environment variable FPGA_FAMILY=$FPGA_FAMILY is not valid"
		echo "Valid are: xczu7ev"
		exit 1
		;;
esac

case "$SD_VERSION" in
	YES)
		echo "Using the generate_bd_sd.tcl version"
		cp generate_bd_sd.tcl generate_bd.tcl
		;;
	NO)
		echo "Using the generate_bd_wifi.tcl version"
		cp generate_bd_wifi.tcl generate_bd.tcl
		;;
	*)
		echo "Using generate_bd.tcl"
		;;
esac

# Unzip IPs
# Dyplo
pushd IP/dyplo
unzip -o TEP_dyplo*.zip
popd
# Qdesys
pushd IP/ip-qdesys
unzip -o *.zip
popd
# Fan controller
pushd IP/ip-topic-fanctrl
unzip -o *.zip
popd

VIVADO_TCL="vivado -nolog -nojournal -mode batch -notrace -source"

$VIVADO_TCL generate_bitstream.tcl -tclargs ${PART}

cp ${PART}/${PART}.runs/impl_1/*.bit fpga.bit
