#!/bin/sh -e

# Check if in right directory and/or build is run
if [ ! -e fpga.bit ]
then
	echo "File 'fpga.bit' not found."
	exit 1
fi



# For future expansion
case "$FPGA_FAMILY" in
	xczu7ev)
		MACHINE=xdpzu7
		;;
	*)
		echo "Environment variable FPGA_FAMILY=$FPGA_FAMILY is not valid"
		echo "Valid are: xczu7ev"
		exit 1
		;;
esac

case "$SD_VERSION" in
	YES)
		config="sd"
		;;
	*)
		config="wifi"
		;;
esac

PART=${FPGA_FAMILY}-fbvb900-2-i



if [ ! -e "${PART}.xsa" ]
then
	echo "File '${PART}.xsa' not found."
	exit 1
fi


PACKAGE_NAME="fpga-image-${MACHINE}-reference"
PACKAGE2_NAME="fpga-hardware-${MACHINE}-reference"

VERSION=`git rev-list HEAD | wc -l`+`git rev-parse --short HEAD`

xz -9 < fpga.bit > ${PACKAGE_NAME}-${config}-${VERSION}.bit.xz
xz -9 < "${PART}.xsa" > ${PACKAGE2_NAME}-${config}-${VERSION}.xsa.xz
