################ 200 Mhz input clock ##################
#######################################################
set_property PACKAGE_PIN AH6 [get_ports {clk_200M_clk_p[0]}]
set_property IOSTANDARD LVDS [get_ports {clk_200M_clk_p[0]}]
create_clock -period 5.000 -name clk_fpga_200M_clk -waveform {0.000 2.500} [get_ports {clk_200M_clk_p[0]}]

################ Configurable input clock ##################
#######################################################
set_property PACKAGE_PIN AH7 [get_ports {clk_fpga_clk_p[0]}]
set_property IOSTANDARD LVDS [get_ports {clk_fpga_clk_p[0]}]
create_clock -period 5.000 -name clk_fpga_clk -waveform {0.000 2.500} [get_ports {clk_fpga_clk_p[0]}]

###################### FAN ###########################
######################################################
set_property PACKAGE_PIN B15 [get_ports {fan_pwm[0]}]
set_property PACKAGE_PIN A15 [get_ports {fan_tacho[0]}]
set_property IOSTANDARD LVCMOS33 [get_ports fan_*]

################## MIPI Camera 0 #####################
######################################################
# CCI (I2C bus)
set_property PACKAGE_PIN AE14 [get_ports MIPI_0_IIC_scl_io]
set_property PACKAGE_PIN AE13 [get_ports MIPI_0_IIC_sda_io]
set_property IOSTANDARD LVCMOS18 [get_ports MIPI_0_IIC_*]
set_property PULLUP true [get_ports MIPI_0_IIC_scl_io]
set_property PULLUP true [get_ports MIPI_0_IIC_sda_io]

################## MIPI Camera 1 #####################
######################################################
# CCI (I2C bus)
set_property PACKAGE_PIN AD14 [get_ports MIPI_1_IIC_scl_io]
set_property PACKAGE_PIN AA14 [get_ports MIPI_1_IIC_sda_io]
set_property IOSTANDARD LVCMOS18 [get_ports MIPI_1_IIC_*]
set_property PULLUP true [get_ports MIPI_1_IIC_scl_io]
set_property PULLUP true [get_ports MIPI_1_IIC_sda_io]

################### MGT REFCLKS ######################
######################################################
set_property PACKAGE_PIN R8 [get_ports Q0_REFCLK0_clk_p]
create_clock -period 10.000 -name Q0_REFCLK0_clk -waveform {0.000 5.000} [get_ports Q0_REFCLK0_clk_p]

set_property PACKAGE_PIN L8 [get_ports Q1_REFCLK0_p]
create_clock -period 6.734 -name Q1_REFCLK0_clk -waveform {0.000 3.367} [get_ports Q1_REFCLK0_p]

set_property PACKAGE_PIN H10 [get_ports Q2_REFCLK0_clk_p]
create_clock -period 10.000 -name Q2_REFCLK0_clk -waveform {0.000 5.000} [get_ports Q2_REFCLK0_clk_p]

################### MOTOR CONTROL  ###################
######################################################
##############################################################################################
 ##############################################################################################
 
# J1 (TEP2-J1) : Motor 0 : 3.3V

 set_property -dict { PACKAGE_PIN A14  IOSTANDARD LVCMOS33 } [get_ports tep2_0_gu_cmd_d[0]]  ; # MC0_PWM_CH0
 set_property -dict { PACKAGE_PIN B14  IOSTANDARD LVCMOS33 } [get_ports tep2_0_gu_cmd_d[1]]  ; # MC0_PWM_CH1
 set_property -dict { PACKAGE_PIN C14  IOSTANDARD LVCMOS33 } [get_ports tep2_0_gu_cmd_d[2]]  ; # MC0_PWM_CH2
#set_property -dict { PACKAGE_PIN ---  IOSTANDARD LVCMOS33 } [get_ports tep2_0_spare_4    ]  ; # --

 set_property -dict { PACKAGE_PIN A13  IOSTANDARD LVCMOS33 } [get_ports tep2_0_gu_cmd_e[0]]  ; # MC0_EN_CH0
 set_property -dict { PACKAGE_PIN B12  IOSTANDARD LVCMOS33 } [get_ports tep2_0_gu_cmd_e[1]]  ; # MC0_EN_CH1
 set_property -dict { PACKAGE_PIN A12  IOSTANDARD LVCMOS33 } [get_ports tep2_0_gu_cmd_e[2]]  ; # MC0_EN_CH2
#set_property -dict { PACKAGE_PIN ---  IOSTANDARD LVCMOS33 } [get_ports tep2_0_spare_10   ]  ; # --

# J1 (TEP2-J2) : Motor 0 : 1.2V

 set_property -dict { PACKAGE_PIN AA7  IOSTANDARD LVCMOS12 } [get_ports tep2_0_adc_ch]       ; # MC0_ADC_CH
 set_property -dict { PACKAGE_PIN Y7   IOSTANDARD LVCMOS12 } [get_ports tep2_0_adc_sck]      ; # MC0_ADC_SCK
 set_property -dict { PACKAGE_PIN AC8  IOSTANDARD LVCMOS12 } [get_ports tep2_0_adc_cs]       ; # MC0_ADC_CS
 set_property -dict { PACKAGE_PIN AA8  IOSTANDARD LVCMOS12 } [get_ports tep2_0_isn_fault]    ; # MC0_SENSOR_FAULT

 set_property -dict { PACKAGE_PIN Y8   IOSTANDARD LVCMOS12 } [get_ports tep2_0_adc_dat[0]]   ; # MC0_ADC0_DO
 set_property -dict { PACKAGE_PIN AC7  IOSTANDARD LVCMOS12 } [get_ports tep2_0_adc_dat[1]]   ; # MC0_ADC1_DO
 set_property -dict { PACKAGE_PIN AD6  IOSTANDARD LVCMOS12 } [get_ports tep2_0_adc_dat[2]]   ; # MC0_ADC2_DO
 set_property -dict { PACKAGE_PIN AC6  IOSTANDARD LVCMOS12 } [get_ports tep2_0_adc_dat[3]]   ; # MC0_ADC3_DO

 
 ##############################################################################################
 ##############################################################################################

# J2 (TEP2-J1) : Motor 1 : 3.3V

 set_property -dict { PACKAGE_PIN A17  IOSTANDARD LVCMOS33 } [get_ports tep2_1_gu_cmd_d[0]]  ; # MC1_PWM_CH0
 set_property -dict { PACKAGE_PIN C17  IOSTANDARD LVCMOS33 } [get_ports tep2_1_gu_cmd_d[1]]  ; # MC1_PWM_CH1
 set_property -dict { PACKAGE_PIN D17  IOSTANDARD LVCMOS33 } [get_ports tep2_1_gu_cmd_d[2]]  ; # MC1_PWM_CH2
#set_property -dict { PACKAGE_PIN ---  IOSTANDARD LVCMOS33 } [get_ports tep2_1_spare_4    ]  ; # --

 set_property -dict { PACKAGE_PIN C16  IOSTANDARD LVCMOS33 } [get_ports tep2_1_gu_cmd_e[0]]  ; # MC1_EN_CH0
 set_property -dict { PACKAGE_PIN A16  IOSTANDARD LVCMOS33 } [get_ports tep2_1_gu_cmd_e[1]]  ; # MC1_EN_CH1
 set_property -dict { PACKAGE_PIN B16  IOSTANDARD LVCMOS33 } [get_ports tep2_1_gu_cmd_e[2]]  ; # MC1_EN_CH2
#set_property -dict { PACKAGE_PIN ---  IOSTANDARD LVCMOS33 } [get_ports tep2_1_spare_10   ]  ; # --

# J2 (TEP2-J2) : Motor 1 : 1.2V

 set_property -dict { PACKAGE_PIN AC9  IOSTANDARD LVCMOS12 } [get_ports tep2_1_adc_ch]       ; # MC1_ADC_CH
 set_property -dict { PACKAGE_PIN Y10  IOSTANDARD LVCMOS12 } [get_ports tep2_1_adc_sck]      ; # MC1_ADC_SCK
 set_property -dict { PACKAGE_PIN AD7  IOSTANDARD LVCMOS12 } [get_ports tep2_1_adc_cs]       ; # MC1_ADC_CS
 set_property -dict { PACKAGE_PIN AD9  IOSTANDARD LVCMOS12 } [get_ports tep2_1_isn_fault]    ; # MC1_SENSOR_FAULT

 set_property -dict { PACKAGE_PIN AA10 IOSTANDARD LVCMOS12 } [get_ports tep2_1_adc_dat[0]]   ; # MC1_ADC0_DO
 set_property -dict { PACKAGE_PIN AB8  IOSTANDARD LVCMOS12 } [get_ports tep2_1_adc_dat[1]]   ; # MC1_ADC1_DO
 set_property -dict { PACKAGE_PIN AE7  IOSTANDARD LVCMOS12 } [get_ports tep2_1_adc_dat[2]]   ; # MC1_ADC2_DO
 set_property -dict { PACKAGE_PIN AB6  IOSTANDARD LVCMOS12 } [get_ports tep2_1_adc_dat[3]]   ; # MC1_ADC3_DO

 ##############################################################################################
 ##############################################################################################

# J3 (TEP2-J1) : Motor 2 : 3.3V

 set_property -dict { PACKAGE_PIN E13  IOSTANDARD LVCMOS33 } [get_ports tep2_2_gu_cmd_d[0]]  ; # MC2_PWM_CH0
 set_property -dict { PACKAGE_PIN E12  IOSTANDARD LVCMOS33 } [get_ports tep2_2_gu_cmd_d[1]]  ; # MC2_PWM_CH1
 set_property -dict { PACKAGE_PIN D14  IOSTANDARD LVCMOS33 } [get_ports tep2_2_gu_cmd_d[2]]  ; # MC2_PWM_CH2
#set_property -dict { PACKAGE_PIN ---  IOSTANDARD LVCMOS33 } [get_ports tep2_2_spare_4    ]  ; # --

 set_property -dict { PACKAGE_PIN F12  IOSTANDARD LVCMOS33 } [get_ports tep2_2_gu_cmd_e[0]]  ; # MC2_EN_CH0
 set_property -dict { PACKAGE_PIN F13  IOSTANDARD LVCMOS33 } [get_ports tep2_2_gu_cmd_e[1]]  ; # MC2_EN_CH1
 set_property -dict { PACKAGE_PIN G14  IOSTANDARD LVCMOS33 } [get_ports tep2_2_gu_cmd_e[2]]  ; # MC2_EN_CH2
#set_property -dict { PACKAGE_PIN ---  IOSTANDARD LVCMOS33 } [get_ports tep2_2_spare_10   ]  ; # --

# J3 (TEP2-J2) : Motor 2 : 3.3V

 set_property -dict { PACKAGE_PIN H12  IOSTANDARD LVCMOS33 } [get_ports tep2_2_adc_ch]       ; # MC2_ADC_CH
 set_property -dict { PACKAGE_PIN D12  IOSTANDARD LVCMOS33 } [get_ports tep2_2_adc_sck]      ; # MC2_ADC_SCK
 set_property -dict { PACKAGE_PIN H13  IOSTANDARD LVCMOS33 } [get_ports tep2_2_adc_cs]       ; # MC2_ADC_CS
 set_property -dict { PACKAGE_PIN G13  IOSTANDARD LVCMOS33 } [get_ports tep2_2_isn_fault]    ; # MC2_SENSOR_FAULT

 set_property -dict { PACKAGE_PIN C13  IOSTANDARD LVCMOS33 } [get_ports tep2_2_adc_dat[0]]   ; # MC2_ADC0_DO
 set_property -dict { PACKAGE_PIN H14  IOSTANDARD LVCMOS33 } [get_ports tep2_2_adc_dat[1]]   ; # MC2_ADC1_DO
 set_property -dict { PACKAGE_PIN C12  IOSTANDARD LVCMOS33 } [get_ports tep2_2_adc_dat[2]]   ; # MC2_ADC2_DO
 set_property -dict { PACKAGE_PIN E14  IOSTANDARD LVCMOS33 } [get_ports tep2_2_adc_dat[3]]   ; # MC2_ADC3_DO

 ##############################################################################################
 ##############################################################################################

# J4 (TEP2-J1) : Motor 3 : 3.3V

 set_property -dict { PACKAGE_PIN D15  IOSTANDARD LVCMOS33 } [get_ports tep2_3_gu_cmd_d[0]]  ; # MC3_PWM_CH0
 set_property -dict { PACKAGE_PIN D16  IOSTANDARD LVCMOS33 } [get_ports tep2_3_gu_cmd_d[1]]  ; # MC3_PWM_CH1
 set_property -dict { PACKAGE_PIN E17  IOSTANDARD LVCMOS33 } [get_ports tep2_3_gu_cmd_d[2]]  ; # MC3_PWM_CH2
#set_property -dict { PACKAGE_PIN ---  IOSTANDARD LVCMOS33 } [get_ports tep2_3_spare_4    ]  ; # --

 set_property -dict { PACKAGE_PIN J14  IOSTANDARD LVCMOS33 } [get_ports tep2_3_gu_cmd_e[0]]  ; # MC3_EN_CH0
 set_property -dict { PACKAGE_PIN K15  IOSTANDARD LVCMOS33 } [get_ports tep2_3_gu_cmd_e[1]]  ; # MC3_EN_CH1
 set_property -dict { PACKAGE_PIN G15  IOSTANDARD LVCMOS33 } [get_ports tep2_3_gu_cmd_e[2]]  ; # MC3_EN_CH2
#set_property -dict { PACKAGE_PIN ---  IOSTANDARD LVCMOS33 } [get_ports tep2_3_spare_10   ]  ; # --

# J4 (TEP2-J2) : Motor 3 : 3.3V

 set_property -dict { PACKAGE_PIN G16  IOSTANDARD LVCMOS33 } [get_ports tep2_3_adc_ch]       ; # MC3_ADC_CH
 set_property -dict { PACKAGE_PIN E15  IOSTANDARD LVCMOS33 } [get_ports tep2_3_adc_sck]      ; # MC3_ADC_SCK
 set_property -dict { PACKAGE_PIN H16  IOSTANDARD LVCMOS33 } [get_ports tep2_3_adc_cs]       ; # MC3_ADC_CS
 set_property -dict { PACKAGE_PIN J15  IOSTANDARD LVCMOS33 } [get_ports tep2_3_isn_fault]    ; # MC3_SENSOR_FAULT

 set_property -dict { PACKAGE_PIN F15  IOSTANDARD LVCMOS33 } [get_ports tep2_3_adc_dat[0]]   ; # MC3_ADC0_DO
 set_property -dict { PACKAGE_PIN J16  IOSTANDARD LVCMOS33 } [get_ports tep2_3_adc_dat[1]]   ; # MC3_ADC1_DO
 set_property -dict { PACKAGE_PIN F16  IOSTANDARD LVCMOS33 } [get_ports tep2_3_adc_dat[2]]   ; # MC3_ADC2_DO
 set_property -dict { PACKAGE_PIN K14  IOSTANDARD LVCMOS33 } [get_ports tep2_3_adc_dat[3]]   ; # MC3_ADC3_DO

 ##############################################################################################
 ##############################################################################################

################### VERSION PINS #####################
######################################################
set_property PACKAGE_PIN AA2 [get_ports {xdp_version[0]}]
set_property PACKAGE_PIN AE4 [get_ports {xdp_version[1]}]
set_property PACKAGE_PIN AD4 [get_ports {xdp_version[2]}]
set_property PACKAGE_PIN AE5 [get_ports {xdp_version[3]}]
set_property IOSTANDARD LVCMOS12 [get_ports xdp_version*]
set_property PULLUP true [get_ports xdp_version*]

################### USER LED #####################
######################################################
set_property PACKAGE_PIN AD15 [get_ports {user_led[0]}]
set_property IOSTANDARD LVCMOS18 [get_ports {user_led[0]}]

################### GPIO MIPI  #######################
######################################################
set_property PACKAGE_PIN AA13 [get_ports {mipi_0_rst[0]}]
# (TODO) set_property PACKAGE_PIN AB13 [get_ports {mipi_0_flash_en[0]}]
set_property PACKAGE_PIN AC14 [get_ports {mipi_0_clk_tmp[0]}]
set_property PACKAGE_PIN AB14 [get_ports {mipi_1_rst[0]}]
# (TODO) set_property PACKAGE_PIN AA15 [get_ports {mipi_1_flash_en[0]}]
set_property PACKAGE_PIN AB15 [get_ports {mipi_1_clk_tmp[0]}]
# (TODO) set_property IOSTANDARD LVCMOS18 [get_ports mipi_*_flash_en*]
set_property IOSTANDARD LVCMOS18 [get_ports mipi_*_rst*]
set_property IOSTANDARD LVCMOS18 [get_ports mipi_*_clk_tmp*]

# Signals below are the TEST 1,2,3 and TX1_GPIO from 2 connectors
set_property PACKAGE_PIN AB4 [get_ports {MIPI_GPIO_tri_io[0]}]
set_property PACKAGE_PIN AC4 [get_ports {MIPI_GPIO_tri_io[1]}]
set_property PACKAGE_PIN AA6 [get_ports {MIPI_GPIO_tri_io[2]}]
set_property PACKAGE_PIN AA5 [get_ports {MIPI_GPIO_tri_io[3]}]
set_property PACKAGE_PIN AA1 [get_ports {MIPI_GPIO_tri_io[4]}]
set_property PACKAGE_PIN W9 [get_ports {MIPI_GPIO_tri_io[5]}]
set_property PACKAGE_PIN AE3 [get_ports {MIPI_GPIO_tri_io[6]}]
set_property PACKAGE_PIN Y1 [get_ports {MIPI_GPIO_tri_io[7]}]
set_property IOSTANDARD LVCMOS12 [get_ports MIPI_GPIO_tri_io*]
# Because of IOSTANDARD LVCMOS12, DRIVE must be set to 8, 12 is not supported
set_property DRIVE 8 [get_ports MIPI_GPIO_tri_io*]

################## EXPANSION GPIO ####################
######################################################
set_property PACKAGE_PIN AJ12 [get_ports {EIO_GPIO_tri_io[0]}]
set_property PACKAGE_PIN AF12 [get_ports {EIO_GPIO_tri_io[1]}]
set_property PACKAGE_PIN AF11 [get_ports {EIO_GPIO_tri_io[2]}]
set_property PACKAGE_PIN AG11 [get_ports {EIO_GPIO_tri_io[3]}]
set_property PACKAGE_PIN AH12 [get_ports {EIO_GPIO_tri_io[4]}]
set_property PACKAGE_PIN AJ11 [get_ports {EIO_GPIO_tri_io[5]}]
set_property PACKAGE_PIN AK11 [get_ports {EIO_GPIO_tri_io[6]}]
set_property PACKAGE_PIN AJ10 [get_ports {EIO_GPIO_tri_io[7]}]
set_property PACKAGE_PIN AK10 [get_ports {EIO_GPIO_tri_io[8]}]
set_property PACKAGE_PIN AG10 [get_ports {EIO_GPIO_tri_io[9]}]
set_property PACKAGE_PIN AK9 [get_ports {EIO_GPIO_tri_io[10]}]
set_property PACKAGE_PIN AK8 [get_ports {EIO_GPIO_tri_io[11]}]
set_property PACKAGE_PIN AF8 [get_ports {EIO_GPIO_tri_io[12]}]
set_property IOSTANDARD LVCMOS18 [get_ports EIO_GPIO_tri_io*]
# I2C bus to Extension IO print
set_property PACKAGE_PIN AH9 [get_ports -regexp -nocase EIO_IIC_sda_io]
set_property PACKAGE_PIN AJ9 [get_ports -regexp -nocase EIO_IIC_scl_io]
set_property IOSTANDARD LVCMOS18 [get_ports -regexp -nocase EIO_IIC_.*]
set_property PULLUP true [get_ports EIO_IIC_scl_io]
set_property PULLUP true [get_ports EIO_IIC_sda_io]
set_property PACKAGE_PIN AF10 [get_ports -regexp -nocase EIO_LED1]
set_property PACKAGE_PIN AH11 [get_ports -regexp -nocase EIO_LED2]
set_property IOSTANDARD LVCMOS18 [get_ports -regexp -nocase EIO_LED.*]
# HDMI I/O ports
set_property PACKAGE_PIN AF7 [get_ports -regexp -nocase HDMI_HPD.*]
set_property IOSTANDARD LVCMOS18 [get_ports -regexp -nocase HDMI_HPD.*]
set_property PACKAGE_PIN AE9 [get_ports -regexp -nocase HDMI_5V_EN.*]
set_property IOSTANDARD LVCMOS18 [get_ports -regexp -nocase HDMI_5V_EN.*]
set_property PACKAGE_PIN AE8 [get_ports -regexp -nocase HDMI_RT_OE.*]
set_property IOSTANDARD LVCMOS18 [get_ports -regexp -nocase HDMI_RT_OE.*]
# HDMI DDC (I2C bus)
set_property PACKAGE_PIN AH8 [get_ports HDMI_DDC_scl_io]
set_property PACKAGE_PIN AG8 [get_ports HDMI_DDC_sda_io]
set_property IOSTANDARD LVCMOS18 [get_ports HDMI_DDC_*]
set_property PULLUP true [get_ports HDMI_DDC_*]

#################### RAPTOR GPIO #####################
######################################################
set_property PACKAGE_PIN AJ15 [get_ports {RAPTOR_GPIO_tri_io[0]}]
set_property PACKAGE_PIN AK15 [get_ports {RAPTOR_GPIO_tri_io[1]}]
set_property PACKAGE_PIN AG14 [get_ports {RAPTOR_GPIO_tri_io[2]}]
set_property PACKAGE_PIN AH14 [get_ports {RAPTOR_GPIO_tri_io[3]}]
set_property PACKAGE_PIN AF15 [get_ports {RAPTOR_GPIO_tri_io[4]}]
set_property PACKAGE_PIN AG15 [get_ports {RAPTOR_GPIO_tri_io[5]}]
set_property PACKAGE_PIN AF16 [get_ports {RAPTOR_GPIO_tri_io[6]}]
set_property PACKAGE_PIN AF17 [get_ports {RAPTOR_GPIO_tri_io[7]}]
set_property PACKAGE_PIN AD17 [get_ports {RAPTOR_GPIO_tri_io[8]}]
set_property PACKAGE_PIN AE17 [get_ports {RAPTOR_GPIO_tri_io[9]}]
set_property PACKAGE_PIN AC16 [get_ports {RAPTOR_GPIO_tri_io[10]}]
set_property PACKAGE_PIN AD16 [get_ports {RAPTOR_GPIO_tri_io[11]}]
set_property IOSTANDARD LVCMOS18 [get_ports RAPTOR_GPIO_tri_io*]

########### Scalable GPIO (to other XDP) #############
######################################################
set_property PACKAGE_PIN AJ5 [get_ports {SCIO_GPIO_tri_io[0]}]
set_property PACKAGE_PIN AK5 [get_ports {SCIO_GPIO_tri_io[1]}]
set_property PACKAGE_PIN AJ4 [get_ports {SCIO_GPIO_tri_io[2]}]
set_property PACKAGE_PIN AK4 [get_ports {SCIO_GPIO_tri_io[3]}]
set_property PACKAGE_PIN AF6 [get_ports {SCIO_GPIO_tri_io[4]}]
set_property PACKAGE_PIN AF5 [get_ports {SCIO_GPIO_tri_io[5]}]
set_property PACKAGE_PIN AK3 [get_ports {SCIO_GPIO_tri_io[6]}]
set_property PACKAGE_PIN AK2 [get_ports {SCIO_GPIO_tri_io[7]}]
set_property PACKAGE_PIN AJ2 [get_ports {SCIO_GPIO_tri_io[8]}]
set_property PACKAGE_PIN AJ1 [get_ports {SCIO_GPIO_tri_io[9]}]
set_property PACKAGE_PIN AH3 [get_ports {SCIO_GPIO_tri_io[10]}]
set_property PACKAGE_PIN AH2 [get_ports {SCIO_GPIO_tri_io[11]}]
set_property IOSTANDARD LVCMOS18 [get_ports SCIO_GPIO_tri_io*]

############# SPI busses to sensors ##################
######################################################
# BUS 0 to Accel and Gyro
set_property PACKAGE_PIN AH16 [get_ports SENS_SPI0_SCK]
set_property PACKAGE_PIN AC18 [get_ports SENS_SPI0_MISO]
set_property PACKAGE_PIN AD19 [get_ports SENS_SPI0_MOSI]
set_property PACKAGE_PIN AE19 [get_ports SENS_SPI0_CS_ACCEL]
set_property PACKAGE_PIN AG16 [get_ports {SENS_SPI0_CS_GYRO[0]}]
set_property PACKAGE_PIN AH17 [get_ports SENS_ACCEL_INT0]
set_property PACKAGE_PIN AJ16 [get_ports SENS_ACCEL_INT1]
set_property PACKAGE_PIN AK17 [get_ports SENS_GYRO_INT0]
set_property PACKAGE_PIN AJ17 [get_ports SENS_GYRO_INT1]
# BUS 1 to Magneto and environment
set_property PACKAGE_PIN AG18 [get_ports SENS_SPI1_SCK]
set_property PACKAGE_PIN AE18 [get_ports SENS_SPI1_MISO]
set_property PACKAGE_PIN AF18 [get_ports SENS_SPI1_MOSI]
set_property PACKAGE_PIN AH18 [get_ports SENS_SPI1_CS_ENV]
set_property PACKAGE_PIN AC17 [get_ports SENS_SPI1_CS_MAGN]
set_property PACKAGE_PIN AK16 [get_ports SENS_MAGN_DRDY]
set_property PACKAGE_PIN AK18 [get_ports SENS_MAGN_INT]
set_property IOSTANDARD LVCMOS18 [get_ports -regexp SENS_SPI.*]
set_property IOSTANDARD LVCMOS18 [get_ports -regexp SENS_ACCEL.*]
set_property IOSTANDARD LVCMOS18 [get_ports -regexp SENS_GYRO.*]
set_property IOSTANDARD LVCMOS18 [get_ports -regexp SENS_MAGN.*]

######################## GPS #########################
######################################################
set_property PACKAGE_PIN AG1 [get_ports SENS_GPS_UART_txd]
set_property PACKAGE_PIN AH1 [get_ports SENS_GPS_UART_rxd]
set_property PACKAGE_PIN AG9 [get_ports SENS_GPS_IIC_scl_io]
set_property PACKAGE_PIN AH4 [get_ports SENS_GPS_IIC_sda_io]
set_property PACKAGE_PIN AF2 [get_ports {SENS_GPS_DSEL[0]}]
set_property PACKAGE_PIN AF1 [get_ports {SENS_GPS_RESET_N[0]}]
set_property PACKAGE_PIN AF3 [get_ports {SENS_GPS_PIO11[0]}]
set_property PACKAGE_PIN AE10 [get_ports {SENS_GPS_PIO13_EINT[0]}]
set_property PACKAGE_PIN AG3 [get_ports {SENS_GPS_PIO14[0]}]
set_property PACKAGE_PIN AG4 [get_ports {SENS_GPS_PIO15[0]}]
set_property IOSTANDARD LVCMOS18 [get_ports -regexp SENS_GPS_.*]
set_property PULLUP true [get_ports SENS_GPS_IIC_scl_io]
set_property PULLUP true [get_ports SENS_GPS_IIC_sda_io]

################# UART TO BT DEVICE ##################
######################################################
set_property PACKAGE_PIN AK14 [get_ports RTS_TO_BT_UART]
set_property PACKAGE_PIN AK13 [get_ports CTS_FROM_BT_UART]
set_property PACKAGE_PIN AJ14 [get_ports TX_TO_BT_UART]
set_property PACKAGE_PIN AK12 [get_ports TX_FROM_BT_UART]
set_property PACKAGE_PIN AK6 [get_ports {BT_EN[0]}]
set_property PACKAGE_PIN AH13 [get_ports BT_DEV_WAKE]
set_property IOSTANDARD LVCMOS18 [get_ports *BT_*]

############ WIFI (SDIO) INTERFACE ###################
######################################################
set_property PACKAGE_PIN AE15 [get_ports {SDIO_WIFI_EN[0]}]
set_property PACKAGE_PIN AA16 [get_ports SDIO_WIFI_WAKE]
set_property PACKAGE_PIN AB16 [get_ports {SDIO_WIFI_data_io[0]}]
set_property PACKAGE_PIN AF13 [get_ports {SDIO_WIFI_data_io[1]}]
set_property PACKAGE_PIN AC19 [get_ports {SDIO_WIFI_data_io[2]}]
set_property PACKAGE_PIN AC13 [get_ports {SDIO_WIFI_data_io[3]}]
set_property PACKAGE_PIN AG13 [get_ports SDIO_WIFI_clk_pin]
set_property PACKAGE_PIN AG19 [get_ports SDIO_WIFI_cmd_io]
set_property IOSTANDARD LVCMOS18 [get_ports SDIO_WIFI*]

###################### MISC ##########################
######################################################
set_property PACKAGE_PIN W8 [get_ports switch_pl_0]
set_property IOSTANDARD LVCMOS12 [get_ports switch_pl_0]
set_property PULLUP true [get_ports switch_pl_0]


