
# Loading additional proc with user specified bodies to compute parameter values.
source [file join [file dirname [file dirname [info script]]] gui/dyplo_axi_v1_8_3.gtcl]

# Definitional proc to organize widgets for parameters.
proc init_gui { IPINST } {
  ipgui::add_param $IPINST -name "Component_Name"
  #Adding Page
  set General [ipgui::add_page $IPINST -name "General"]
  set_property tooltip {General} ${General}
  #Adding Group
  set IP_version [ipgui::add_group $IPINST -name "IP version" -parent ${General}]
  set_property tooltip {IP version} ${IP_version}
  ipgui::add_param $IPINST -name "DYPLO_IP_VERSION" -parent ${IP_version}
  ipgui::add_param $IPINST -name "DYPLO_IP_RELEASE" -parent ${IP_version}
  ipgui::add_param $IPINST -name "DYPLO_IP_BUILD" -parent ${IP_version}

  #Adding Group
  set Framework_version [ipgui::add_group $IPINST -name "Framework version" -parent ${General}]
  set_property tooltip {Framework version} ${Framework_version}
  ipgui::add_param $IPINST -name "FRAMEWORK_VENDOR" -parent ${Framework_version}
  ipgui::add_param $IPINST -name "FRAMEWORK_PRODUCT" -parent ${Framework_version}
  ipgui::add_param $IPINST -name "FRAMEWORK_VERSION" -parent ${Framework_version}
  ipgui::add_param $IPINST -name "FRAMEWORK_REVISION" -parent ${Framework_version}


  #Adding Page
  set Architecture [ipgui::add_page $IPINST -name "Architecture"]
  set_property tooltip {Architecture} ${Architecture}
  #Adding Group
  set Connect_lanes [ipgui::add_group $IPINST -name "Connect lanes" -parent ${Architecture}]
  set CONNECT_LANES [ipgui::add_param $IPINST -name "CONNECT_LANES" -parent ${Connect_lanes}]
  set_property tooltip {Number of lanes in the Dyplo connect (backplane)} ${CONNECT_LANES}

  #Adding Group
  set Monitor [ipgui::add_group $IPINST -name "Monitor" -parent ${Architecture}]
  set MONITOR [ipgui::add_param $IPINST -name "MONITOR" -parent ${Monitor}]
  set_property tooltip {In- or Exclude monitor functionality} ${MONITOR}

  #Adding Group
  set Interrupts [ipgui::add_group $IPINST -name "Interrupts" -parent ${Architecture}]
  set C_IRQ_TYPE [ipgui::add_param $IPINST -name "C_IRQ_TYPE" -parent ${Interrupts} -widget comboBox]
  set_property tooltip {Type of interrupt for dyplo_irq signal} ${C_IRQ_TYPE}

  #Adding Group
  set FPGA_Architecture [ipgui::add_group $IPINST -name "FPGA Architecture" -parent ${Architecture}]
  set DEVICE_ARCHITECTURE [ipgui::add_param $IPINST -name "DEVICE_ARCHITECTURE" -parent ${FPGA_Architecture} -widget comboBox]
  set_property tooltip {Device Architecture of FPGA} ${DEVICE_ARCHITECTURE}


  #Adding Page
  set Nodes [ipgui::add_page $IPINST -name "Nodes"]
  set_property tooltip {Nodes} ${Nodes}
  #Adding Group
  set CPU_nodes [ipgui::add_group $IPINST -name "CPU nodes" -parent ${Nodes}]
  set_property tooltip {CPU nodes} ${CPU_nodes}
  ipgui::add_param $IPINST -name "CPU_TO_FPGA_STREAMS" -parent ${CPU_nodes}
  ipgui::add_param $IPINST -name "FPGA_TO_CPU_STREAMS" -parent ${CPU_nodes}

  #Adding Group
  set IO_nodes [ipgui::add_group $IPINST -name "IO nodes" -parent ${Nodes}]
  ipgui::add_param $IPINST -name "IO_NODES" -parent ${IO_nodes}
  ipgui::add_param $IPINST -name "IO_NODE_1_INSTREAMS" -parent ${IO_nodes}
  ipgui::add_param $IPINST -name "IO_NODE_1_OUTSTREAMS" -parent ${IO_nodes}
  ipgui::add_param $IPINST -name "IO_NODE_2_INSTREAMS" -parent ${IO_nodes}
  ipgui::add_param $IPINST -name "IO_NODE_2_OUTSTREAMS" -parent ${IO_nodes}
  ipgui::add_param $IPINST -name "IO_NODE_3_INSTREAMS" -parent ${IO_nodes}
  ipgui::add_param $IPINST -name "IO_NODE_3_OUTSTREAMS" -parent ${IO_nodes}
  ipgui::add_param $IPINST -name "IO_NODE_4_INSTREAMS" -parent ${IO_nodes}
  ipgui::add_param $IPINST -name "IO_NODE_4_OUTSTREAMS" -parent ${IO_nodes}

  #Adding Group
  set User_logic_nodes [ipgui::add_group $IPINST -name "User logic nodes" -parent ${Nodes}]
  set_property tooltip {User logic nodes} ${User_logic_nodes}
  ipgui::add_param $IPINST -name "FIXED_NODES" -parent ${User_logic_nodes}
  ipgui::add_param $IPINST -name "PR_NODES" -parent ${User_logic_nodes}

  #Adding Group
  set DMA_nodes [ipgui::add_group $IPINST -name "DMA nodes" -parent ${Nodes}]
  set_property tooltip {DMA nodes} ${DMA_nodes}
  ipgui::add_param $IPINST -name "DMA_NODES" -parent ${DMA_nodes}


  #Adding Page
  set AHB_/_AXI_Settings [ipgui::add_page $IPINST -name "AHB / AXI Settings"]
  set_property tooltip {AHB / AXI Settings} ${AHB_/_AXI_Settings}
  ipgui::add_param $IPINST -name "CONTROL_INTERFACE_TYPE" -parent ${AHB_/_AXI_Settings} -widget comboBox
  ipgui::add_param $IPINST -name "CONTROL_DATA_WIDTH" -parent ${AHB_/_AXI_Settings}
  ipgui::add_param $IPINST -name "CONTROL_ADDR_WIDTH" -parent ${AHB_/_AXI_Settings}
  ipgui::add_param $IPINST -name "CONTROL_AXI_ID_WIDTH" -parent ${AHB_/_AXI_Settings}
  ipgui::add_param $IPINST -name "DMA_INTERFACE_TYPE" -parent ${AHB_/_AXI_Settings} -widget comboBox
  ipgui::add_param $IPINST -name "DMA_DATA_WIDTH" -parent ${AHB_/_AXI_Settings}
  ipgui::add_param $IPINST -name "DMA_ADDR_WIDTH" -parent ${AHB_/_AXI_Settings}
  ipgui::add_param $IPINST -name "DMA_AXI_ID_WIDTH" -parent ${AHB_/_AXI_Settings}


}

proc update_PARAM_VALUE.CONTROL_AXI_ID_WIDTH { PARAM_VALUE.CONTROL_AXI_ID_WIDTH PARAM_VALUE.CONTROL_INTERFACE_TYPE } {
	# Procedure called to update CONTROL_AXI_ID_WIDTH when any of the dependent parameters in the arguments change
	
	set CONTROL_AXI_ID_WIDTH ${PARAM_VALUE.CONTROL_AXI_ID_WIDTH}
	set CONTROL_INTERFACE_TYPE ${PARAM_VALUE.CONTROL_INTERFACE_TYPE}
	set values(CONTROL_INTERFACE_TYPE) [get_property value $CONTROL_INTERFACE_TYPE]
	if { [gen_USERPARAMETER_CONTROL_AXI_ID_WIDTH_ENABLEMENT $values(CONTROL_INTERFACE_TYPE)] } {
		set_property enabled true $CONTROL_AXI_ID_WIDTH
	} else {
		set_property enabled false $CONTROL_AXI_ID_WIDTH
	}
}

proc validate_PARAM_VALUE.CONTROL_AXI_ID_WIDTH { PARAM_VALUE.CONTROL_AXI_ID_WIDTH } {
	# Procedure called to validate CONTROL_AXI_ID_WIDTH
	return true
}

proc update_PARAM_VALUE.DMA_AXI_ID_WIDTH { PARAM_VALUE.DMA_AXI_ID_WIDTH PARAM_VALUE.DMA_INTERFACE_TYPE } {
	# Procedure called to update DMA_AXI_ID_WIDTH when any of the dependent parameters in the arguments change
	
	set DMA_AXI_ID_WIDTH ${PARAM_VALUE.DMA_AXI_ID_WIDTH}
	set DMA_INTERFACE_TYPE ${PARAM_VALUE.DMA_INTERFACE_TYPE}
	set values(DMA_INTERFACE_TYPE) [get_property value $DMA_INTERFACE_TYPE]
	if { [gen_USERPARAMETER_DMA_AXI_ID_WIDTH_ENABLEMENT $values(DMA_INTERFACE_TYPE)] } {
		set_property enabled true $DMA_AXI_ID_WIDTH
	} else {
		set_property enabled false $DMA_AXI_ID_WIDTH
	}
}

proc validate_PARAM_VALUE.DMA_AXI_ID_WIDTH { PARAM_VALUE.DMA_AXI_ID_WIDTH } {
	# Procedure called to validate DMA_AXI_ID_WIDTH
	return true
}

proc update_PARAM_VALUE.CONNECT_LANES { PARAM_VALUE.CONNECT_LANES } {
	# Procedure called to update CONNECT_LANES when any of the dependent parameters in the arguments change
}

proc validate_PARAM_VALUE.CONNECT_LANES { PARAM_VALUE.CONNECT_LANES } {
	# Procedure called to validate CONNECT_LANES
	return true
}

proc update_PARAM_VALUE.CONTROL_ADDR_WIDTH { PARAM_VALUE.CONTROL_ADDR_WIDTH } {
	# Procedure called to update CONTROL_ADDR_WIDTH when any of the dependent parameters in the arguments change
}

proc validate_PARAM_VALUE.CONTROL_ADDR_WIDTH { PARAM_VALUE.CONTROL_ADDR_WIDTH } {
	# Procedure called to validate CONTROL_ADDR_WIDTH
	return true
}

proc update_PARAM_VALUE.CONTROL_DATA_WIDTH { PARAM_VALUE.CONTROL_DATA_WIDTH } {
	# Procedure called to update CONTROL_DATA_WIDTH when any of the dependent parameters in the arguments change
}

proc validate_PARAM_VALUE.CONTROL_DATA_WIDTH { PARAM_VALUE.CONTROL_DATA_WIDTH } {
	# Procedure called to validate CONTROL_DATA_WIDTH
	return true
}

proc update_PARAM_VALUE.CONTROL_INTERFACE_TYPE { PARAM_VALUE.CONTROL_INTERFACE_TYPE } {
	# Procedure called to update CONTROL_INTERFACE_TYPE when any of the dependent parameters in the arguments change
}

proc validate_PARAM_VALUE.CONTROL_INTERFACE_TYPE { PARAM_VALUE.CONTROL_INTERFACE_TYPE } {
	# Procedure called to validate CONTROL_INTERFACE_TYPE
	return true
}

proc update_PARAM_VALUE.CPU_TO_FPGA_STREAMS { PARAM_VALUE.CPU_TO_FPGA_STREAMS } {
	# Procedure called to update CPU_TO_FPGA_STREAMS when any of the dependent parameters in the arguments change
}

proc validate_PARAM_VALUE.CPU_TO_FPGA_STREAMS { PARAM_VALUE.CPU_TO_FPGA_STREAMS } {
	# Procedure called to validate CPU_TO_FPGA_STREAMS
	return true
}

proc update_PARAM_VALUE.C_IRQ_TYPE { PARAM_VALUE.C_IRQ_TYPE } {
	# Procedure called to update C_IRQ_TYPE when any of the dependent parameters in the arguments change
}

proc validate_PARAM_VALUE.C_IRQ_TYPE { PARAM_VALUE.C_IRQ_TYPE } {
	# Procedure called to validate C_IRQ_TYPE
	return true
}

proc update_PARAM_VALUE.DEVICE_ARCHITECTURE { PARAM_VALUE.DEVICE_ARCHITECTURE } {
	# Procedure called to update DEVICE_ARCHITECTURE when any of the dependent parameters in the arguments change
}

proc validate_PARAM_VALUE.DEVICE_ARCHITECTURE { PARAM_VALUE.DEVICE_ARCHITECTURE } {
	# Procedure called to validate DEVICE_ARCHITECTURE
	return true
}

proc update_PARAM_VALUE.DMA_ADDR_WIDTH { PARAM_VALUE.DMA_ADDR_WIDTH } {
	# Procedure called to update DMA_ADDR_WIDTH when any of the dependent parameters in the arguments change
}

proc validate_PARAM_VALUE.DMA_ADDR_WIDTH { PARAM_VALUE.DMA_ADDR_WIDTH } {
	# Procedure called to validate DMA_ADDR_WIDTH
	return true
}

proc update_PARAM_VALUE.DMA_DATA_WIDTH { PARAM_VALUE.DMA_DATA_WIDTH } {
	# Procedure called to update DMA_DATA_WIDTH when any of the dependent parameters in the arguments change
}

proc validate_PARAM_VALUE.DMA_DATA_WIDTH { PARAM_VALUE.DMA_DATA_WIDTH } {
	# Procedure called to validate DMA_DATA_WIDTH
	return true
}

proc update_PARAM_VALUE.DMA_INTERFACE_TYPE { PARAM_VALUE.DMA_INTERFACE_TYPE } {
	# Procedure called to update DMA_INTERFACE_TYPE when any of the dependent parameters in the arguments change
}

proc validate_PARAM_VALUE.DMA_INTERFACE_TYPE { PARAM_VALUE.DMA_INTERFACE_TYPE } {
	# Procedure called to validate DMA_INTERFACE_TYPE
	return true
}

proc update_PARAM_VALUE.DMA_NODES { PARAM_VALUE.DMA_NODES } {
	# Procedure called to update DMA_NODES when any of the dependent parameters in the arguments change
}

proc validate_PARAM_VALUE.DMA_NODES { PARAM_VALUE.DMA_NODES } {
	# Procedure called to validate DMA_NODES
	return true
}

proc update_PARAM_VALUE.DYPLO_IP_BUILD { PARAM_VALUE.DYPLO_IP_BUILD } {
	# Procedure called to update DYPLO_IP_BUILD when any of the dependent parameters in the arguments change
}

proc validate_PARAM_VALUE.DYPLO_IP_BUILD { PARAM_VALUE.DYPLO_IP_BUILD } {
	# Procedure called to validate DYPLO_IP_BUILD
	return true
}

proc update_PARAM_VALUE.DYPLO_IP_RELEASE { PARAM_VALUE.DYPLO_IP_RELEASE } {
	# Procedure called to update DYPLO_IP_RELEASE when any of the dependent parameters in the arguments change
}

proc validate_PARAM_VALUE.DYPLO_IP_RELEASE { PARAM_VALUE.DYPLO_IP_RELEASE } {
	# Procedure called to validate DYPLO_IP_RELEASE
	return true
}

proc update_PARAM_VALUE.DYPLO_IP_VERSION { PARAM_VALUE.DYPLO_IP_VERSION } {
	# Procedure called to update DYPLO_IP_VERSION when any of the dependent parameters in the arguments change
}

proc validate_PARAM_VALUE.DYPLO_IP_VERSION { PARAM_VALUE.DYPLO_IP_VERSION } {
	# Procedure called to validate DYPLO_IP_VERSION
	return true
}

proc update_PARAM_VALUE.FIXED_NODES { PARAM_VALUE.FIXED_NODES } {
	# Procedure called to update FIXED_NODES when any of the dependent parameters in the arguments change
}

proc validate_PARAM_VALUE.FIXED_NODES { PARAM_VALUE.FIXED_NODES } {
	# Procedure called to validate FIXED_NODES
	return true
}

proc update_PARAM_VALUE.FPGA_TO_CPU_STREAMS { PARAM_VALUE.FPGA_TO_CPU_STREAMS } {
	# Procedure called to update FPGA_TO_CPU_STREAMS when any of the dependent parameters in the arguments change
}

proc validate_PARAM_VALUE.FPGA_TO_CPU_STREAMS { PARAM_VALUE.FPGA_TO_CPU_STREAMS } {
	# Procedure called to validate FPGA_TO_CPU_STREAMS
	return true
}

proc update_PARAM_VALUE.FRAMEWORK_PRODUCT { PARAM_VALUE.FRAMEWORK_PRODUCT } {
	# Procedure called to update FRAMEWORK_PRODUCT when any of the dependent parameters in the arguments change
}

proc validate_PARAM_VALUE.FRAMEWORK_PRODUCT { PARAM_VALUE.FRAMEWORK_PRODUCT } {
	# Procedure called to validate FRAMEWORK_PRODUCT
	return true
}

proc update_PARAM_VALUE.FRAMEWORK_REVISION { PARAM_VALUE.FRAMEWORK_REVISION } {
	# Procedure called to update FRAMEWORK_REVISION when any of the dependent parameters in the arguments change
}

proc validate_PARAM_VALUE.FRAMEWORK_REVISION { PARAM_VALUE.FRAMEWORK_REVISION } {
	# Procedure called to validate FRAMEWORK_REVISION
	return true
}

proc update_PARAM_VALUE.FRAMEWORK_VENDOR { PARAM_VALUE.FRAMEWORK_VENDOR } {
	# Procedure called to update FRAMEWORK_VENDOR when any of the dependent parameters in the arguments change
}

proc validate_PARAM_VALUE.FRAMEWORK_VENDOR { PARAM_VALUE.FRAMEWORK_VENDOR } {
	# Procedure called to validate FRAMEWORK_VENDOR
	return true
}

proc update_PARAM_VALUE.FRAMEWORK_VERSION { PARAM_VALUE.FRAMEWORK_VERSION } {
	# Procedure called to update FRAMEWORK_VERSION when any of the dependent parameters in the arguments change
}

proc validate_PARAM_VALUE.FRAMEWORK_VERSION { PARAM_VALUE.FRAMEWORK_VERSION } {
	# Procedure called to validate FRAMEWORK_VERSION
	return true
}

proc update_PARAM_VALUE.IO_NODES { PARAM_VALUE.IO_NODES } {
	# Procedure called to update IO_NODES when any of the dependent parameters in the arguments change
}

proc validate_PARAM_VALUE.IO_NODES { PARAM_VALUE.IO_NODES } {
	# Procedure called to validate IO_NODES
	return true
}

proc update_PARAM_VALUE.IO_NODE_1_INSTREAMS { PARAM_VALUE.IO_NODE_1_INSTREAMS } {
	# Procedure called to update IO_NODE_1_INSTREAMS when any of the dependent parameters in the arguments change
}

proc validate_PARAM_VALUE.IO_NODE_1_INSTREAMS { PARAM_VALUE.IO_NODE_1_INSTREAMS } {
	# Procedure called to validate IO_NODE_1_INSTREAMS
	return true
}

proc update_PARAM_VALUE.IO_NODE_1_OUTSTREAMS { PARAM_VALUE.IO_NODE_1_OUTSTREAMS } {
	# Procedure called to update IO_NODE_1_OUTSTREAMS when any of the dependent parameters in the arguments change
}

proc validate_PARAM_VALUE.IO_NODE_1_OUTSTREAMS { PARAM_VALUE.IO_NODE_1_OUTSTREAMS } {
	# Procedure called to validate IO_NODE_1_OUTSTREAMS
	return true
}

proc update_PARAM_VALUE.IO_NODE_2_INSTREAMS { PARAM_VALUE.IO_NODE_2_INSTREAMS } {
	# Procedure called to update IO_NODE_2_INSTREAMS when any of the dependent parameters in the arguments change
}

proc validate_PARAM_VALUE.IO_NODE_2_INSTREAMS { PARAM_VALUE.IO_NODE_2_INSTREAMS } {
	# Procedure called to validate IO_NODE_2_INSTREAMS
	return true
}

proc update_PARAM_VALUE.IO_NODE_2_OUTSTREAMS { PARAM_VALUE.IO_NODE_2_OUTSTREAMS } {
	# Procedure called to update IO_NODE_2_OUTSTREAMS when any of the dependent parameters in the arguments change
}

proc validate_PARAM_VALUE.IO_NODE_2_OUTSTREAMS { PARAM_VALUE.IO_NODE_2_OUTSTREAMS } {
	# Procedure called to validate IO_NODE_2_OUTSTREAMS
	return true
}

proc update_PARAM_VALUE.IO_NODE_3_INSTREAMS { PARAM_VALUE.IO_NODE_3_INSTREAMS } {
	# Procedure called to update IO_NODE_3_INSTREAMS when any of the dependent parameters in the arguments change
}

proc validate_PARAM_VALUE.IO_NODE_3_INSTREAMS { PARAM_VALUE.IO_NODE_3_INSTREAMS } {
	# Procedure called to validate IO_NODE_3_INSTREAMS
	return true
}

proc update_PARAM_VALUE.IO_NODE_3_OUTSTREAMS { PARAM_VALUE.IO_NODE_3_OUTSTREAMS } {
	# Procedure called to update IO_NODE_3_OUTSTREAMS when any of the dependent parameters in the arguments change
}

proc validate_PARAM_VALUE.IO_NODE_3_OUTSTREAMS { PARAM_VALUE.IO_NODE_3_OUTSTREAMS } {
	# Procedure called to validate IO_NODE_3_OUTSTREAMS
	return true
}

proc update_PARAM_VALUE.IO_NODE_4_INSTREAMS { PARAM_VALUE.IO_NODE_4_INSTREAMS } {
	# Procedure called to update IO_NODE_4_INSTREAMS when any of the dependent parameters in the arguments change
}

proc validate_PARAM_VALUE.IO_NODE_4_INSTREAMS { PARAM_VALUE.IO_NODE_4_INSTREAMS } {
	# Procedure called to validate IO_NODE_4_INSTREAMS
	return true
}

proc update_PARAM_VALUE.IO_NODE_4_OUTSTREAMS { PARAM_VALUE.IO_NODE_4_OUTSTREAMS } {
	# Procedure called to update IO_NODE_4_OUTSTREAMS when any of the dependent parameters in the arguments change
}

proc validate_PARAM_VALUE.IO_NODE_4_OUTSTREAMS { PARAM_VALUE.IO_NODE_4_OUTSTREAMS } {
	# Procedure called to validate IO_NODE_4_OUTSTREAMS
	return true
}

proc update_PARAM_VALUE.MONITOR { PARAM_VALUE.MONITOR } {
	# Procedure called to update MONITOR when any of the dependent parameters in the arguments change
}

proc validate_PARAM_VALUE.MONITOR { PARAM_VALUE.MONITOR } {
	# Procedure called to validate MONITOR
	return true
}

proc update_PARAM_VALUE.PR_NODES { PARAM_VALUE.PR_NODES } {
	# Procedure called to update PR_NODES when any of the dependent parameters in the arguments change
}

proc validate_PARAM_VALUE.PR_NODES { PARAM_VALUE.PR_NODES } {
	# Procedure called to validate PR_NODES
	return true
}

proc update_PARAM_VALUE.STATIC_BITSTREAM_ID { PARAM_VALUE.STATIC_BITSTREAM_ID } {
	# Procedure called to update STATIC_BITSTREAM_ID when any of the dependent parameters in the arguments change
}

proc validate_PARAM_VALUE.STATIC_BITSTREAM_ID { PARAM_VALUE.STATIC_BITSTREAM_ID } {
	# Procedure called to validate STATIC_BITSTREAM_ID
	return true
}


proc update_MODELPARAM_VALUE.CONTROL_INTERFACE_TYPE { MODELPARAM_VALUE.CONTROL_INTERFACE_TYPE PARAM_VALUE.CONTROL_INTERFACE_TYPE } {
	# Procedure called to set VHDL generic/Verilog parameter value(s) based on TCL parameter value
	set_property value [get_property value ${PARAM_VALUE.CONTROL_INTERFACE_TYPE}] ${MODELPARAM_VALUE.CONTROL_INTERFACE_TYPE}
}

proc update_MODELPARAM_VALUE.CONTROL_DATA_WIDTH { MODELPARAM_VALUE.CONTROL_DATA_WIDTH PARAM_VALUE.CONTROL_DATA_WIDTH } {
	# Procedure called to set VHDL generic/Verilog parameter value(s) based on TCL parameter value
	set_property value [get_property value ${PARAM_VALUE.CONTROL_DATA_WIDTH}] ${MODELPARAM_VALUE.CONTROL_DATA_WIDTH}
}

proc update_MODELPARAM_VALUE.CONTROL_ADDR_WIDTH { MODELPARAM_VALUE.CONTROL_ADDR_WIDTH PARAM_VALUE.CONTROL_ADDR_WIDTH } {
	# Procedure called to set VHDL generic/Verilog parameter value(s) based on TCL parameter value
	set_property value [get_property value ${PARAM_VALUE.CONTROL_ADDR_WIDTH}] ${MODELPARAM_VALUE.CONTROL_ADDR_WIDTH}
}

proc update_MODELPARAM_VALUE.CONTROL_AXI_ID_WIDTH { MODELPARAM_VALUE.CONTROL_AXI_ID_WIDTH PARAM_VALUE.CONTROL_AXI_ID_WIDTH } {
	# Procedure called to set VHDL generic/Verilog parameter value(s) based on TCL parameter value
	set_property value [get_property value ${PARAM_VALUE.CONTROL_AXI_ID_WIDTH}] ${MODELPARAM_VALUE.CONTROL_AXI_ID_WIDTH}
}

proc update_MODELPARAM_VALUE.DYPLO_IP_VERSION { MODELPARAM_VALUE.DYPLO_IP_VERSION PARAM_VALUE.DYPLO_IP_VERSION } {
	# Procedure called to set VHDL generic/Verilog parameter value(s) based on TCL parameter value
	set_property value [get_property value ${PARAM_VALUE.DYPLO_IP_VERSION}] ${MODELPARAM_VALUE.DYPLO_IP_VERSION}
}

proc update_MODELPARAM_VALUE.DYPLO_IP_RELEASE { MODELPARAM_VALUE.DYPLO_IP_RELEASE PARAM_VALUE.DYPLO_IP_RELEASE } {
	# Procedure called to set VHDL generic/Verilog parameter value(s) based on TCL parameter value
	set_property value [get_property value ${PARAM_VALUE.DYPLO_IP_RELEASE}] ${MODELPARAM_VALUE.DYPLO_IP_RELEASE}
}

proc update_MODELPARAM_VALUE.DYPLO_IP_BUILD { MODELPARAM_VALUE.DYPLO_IP_BUILD PARAM_VALUE.DYPLO_IP_BUILD } {
	# Procedure called to set VHDL generic/Verilog parameter value(s) based on TCL parameter value
	set_property value [get_property value ${PARAM_VALUE.DYPLO_IP_BUILD}] ${MODELPARAM_VALUE.DYPLO_IP_BUILD}
}

proc update_MODELPARAM_VALUE.FRAMEWORK_VENDOR { MODELPARAM_VALUE.FRAMEWORK_VENDOR PARAM_VALUE.FRAMEWORK_VENDOR } {
	# Procedure called to set VHDL generic/Verilog parameter value(s) based on TCL parameter value
	set_property value [get_property value ${PARAM_VALUE.FRAMEWORK_VENDOR}] ${MODELPARAM_VALUE.FRAMEWORK_VENDOR}
}

proc update_MODELPARAM_VALUE.FRAMEWORK_PRODUCT { MODELPARAM_VALUE.FRAMEWORK_PRODUCT PARAM_VALUE.FRAMEWORK_PRODUCT } {
	# Procedure called to set VHDL generic/Verilog parameter value(s) based on TCL parameter value
	set_property value [get_property value ${PARAM_VALUE.FRAMEWORK_PRODUCT}] ${MODELPARAM_VALUE.FRAMEWORK_PRODUCT}
}

proc update_MODELPARAM_VALUE.FRAMEWORK_VERSION { MODELPARAM_VALUE.FRAMEWORK_VERSION PARAM_VALUE.FRAMEWORK_VERSION } {
	# Procedure called to set VHDL generic/Verilog parameter value(s) based on TCL parameter value
	set_property value [get_property value ${PARAM_VALUE.FRAMEWORK_VERSION}] ${MODELPARAM_VALUE.FRAMEWORK_VERSION}
}

proc update_MODELPARAM_VALUE.FRAMEWORK_REVISION { MODELPARAM_VALUE.FRAMEWORK_REVISION PARAM_VALUE.FRAMEWORK_REVISION } {
	# Procedure called to set VHDL generic/Verilog parameter value(s) based on TCL parameter value
	set_property value [get_property value ${PARAM_VALUE.FRAMEWORK_REVISION}] ${MODELPARAM_VALUE.FRAMEWORK_REVISION}
}

proc update_MODELPARAM_VALUE.STATIC_BITSTREAM_ID { MODELPARAM_VALUE.STATIC_BITSTREAM_ID PARAM_VALUE.STATIC_BITSTREAM_ID } {
	# Procedure called to set VHDL generic/Verilog parameter value(s) based on TCL parameter value
	set_property value [get_property value ${PARAM_VALUE.STATIC_BITSTREAM_ID}] ${MODELPARAM_VALUE.STATIC_BITSTREAM_ID}
}

proc update_MODELPARAM_VALUE.CPU_TO_FPGA_STREAMS { MODELPARAM_VALUE.CPU_TO_FPGA_STREAMS PARAM_VALUE.CPU_TO_FPGA_STREAMS } {
	# Procedure called to set VHDL generic/Verilog parameter value(s) based on TCL parameter value
	set_property value [get_property value ${PARAM_VALUE.CPU_TO_FPGA_STREAMS}] ${MODELPARAM_VALUE.CPU_TO_FPGA_STREAMS}
}

proc update_MODELPARAM_VALUE.FPGA_TO_CPU_STREAMS { MODELPARAM_VALUE.FPGA_TO_CPU_STREAMS PARAM_VALUE.FPGA_TO_CPU_STREAMS } {
	# Procedure called to set VHDL generic/Verilog parameter value(s) based on TCL parameter value
	set_property value [get_property value ${PARAM_VALUE.FPGA_TO_CPU_STREAMS}] ${MODELPARAM_VALUE.FPGA_TO_CPU_STREAMS}
}

proc update_MODELPARAM_VALUE.IO_NODES { MODELPARAM_VALUE.IO_NODES PARAM_VALUE.IO_NODES } {
	# Procedure called to set VHDL generic/Verilog parameter value(s) based on TCL parameter value
	set_property value [get_property value ${PARAM_VALUE.IO_NODES}] ${MODELPARAM_VALUE.IO_NODES}
}

proc update_MODELPARAM_VALUE.FIXED_NODES { MODELPARAM_VALUE.FIXED_NODES PARAM_VALUE.FIXED_NODES } {
	# Procedure called to set VHDL generic/Verilog parameter value(s) based on TCL parameter value
	set_property value [get_property value ${PARAM_VALUE.FIXED_NODES}] ${MODELPARAM_VALUE.FIXED_NODES}
}

proc update_MODELPARAM_VALUE.PR_NODES { MODELPARAM_VALUE.PR_NODES PARAM_VALUE.PR_NODES } {
	# Procedure called to set VHDL generic/Verilog parameter value(s) based on TCL parameter value
	set_property value [get_property value ${PARAM_VALUE.PR_NODES}] ${MODELPARAM_VALUE.PR_NODES}
}

proc update_MODELPARAM_VALUE.DMA_NODES { MODELPARAM_VALUE.DMA_NODES PARAM_VALUE.DMA_NODES } {
	# Procedure called to set VHDL generic/Verilog parameter value(s) based on TCL parameter value
	set_property value [get_property value ${PARAM_VALUE.DMA_NODES}] ${MODELPARAM_VALUE.DMA_NODES}
}

proc update_MODELPARAM_VALUE.CONNECT_LANES { MODELPARAM_VALUE.CONNECT_LANES PARAM_VALUE.CONNECT_LANES } {
	# Procedure called to set VHDL generic/Verilog parameter value(s) based on TCL parameter value
	set_property value [get_property value ${PARAM_VALUE.CONNECT_LANES}] ${MODELPARAM_VALUE.CONNECT_LANES}
}

proc update_MODELPARAM_VALUE.MONITOR { MODELPARAM_VALUE.MONITOR PARAM_VALUE.MONITOR } {
	# Procedure called to set VHDL generic/Verilog parameter value(s) based on TCL parameter value
	set_property value [get_property value ${PARAM_VALUE.MONITOR}] ${MODELPARAM_VALUE.MONITOR}
}

proc update_MODELPARAM_VALUE.IO_NODE_1_INSTREAMS { MODELPARAM_VALUE.IO_NODE_1_INSTREAMS PARAM_VALUE.IO_NODE_1_INSTREAMS } {
	# Procedure called to set VHDL generic/Verilog parameter value(s) based on TCL parameter value
	set_property value [get_property value ${PARAM_VALUE.IO_NODE_1_INSTREAMS}] ${MODELPARAM_VALUE.IO_NODE_1_INSTREAMS}
}

proc update_MODELPARAM_VALUE.IO_NODE_1_OUTSTREAMS { MODELPARAM_VALUE.IO_NODE_1_OUTSTREAMS PARAM_VALUE.IO_NODE_1_OUTSTREAMS } {
	# Procedure called to set VHDL generic/Verilog parameter value(s) based on TCL parameter value
	set_property value [get_property value ${PARAM_VALUE.IO_NODE_1_OUTSTREAMS}] ${MODELPARAM_VALUE.IO_NODE_1_OUTSTREAMS}
}

proc update_MODELPARAM_VALUE.IO_NODE_2_INSTREAMS { MODELPARAM_VALUE.IO_NODE_2_INSTREAMS PARAM_VALUE.IO_NODE_2_INSTREAMS } {
	# Procedure called to set VHDL generic/Verilog parameter value(s) based on TCL parameter value
	set_property value [get_property value ${PARAM_VALUE.IO_NODE_2_INSTREAMS}] ${MODELPARAM_VALUE.IO_NODE_2_INSTREAMS}
}

proc update_MODELPARAM_VALUE.IO_NODE_2_OUTSTREAMS { MODELPARAM_VALUE.IO_NODE_2_OUTSTREAMS PARAM_VALUE.IO_NODE_2_OUTSTREAMS } {
	# Procedure called to set VHDL generic/Verilog parameter value(s) based on TCL parameter value
	set_property value [get_property value ${PARAM_VALUE.IO_NODE_2_OUTSTREAMS}] ${MODELPARAM_VALUE.IO_NODE_2_OUTSTREAMS}
}

proc update_MODELPARAM_VALUE.IO_NODE_3_INSTREAMS { MODELPARAM_VALUE.IO_NODE_3_INSTREAMS PARAM_VALUE.IO_NODE_3_INSTREAMS } {
	# Procedure called to set VHDL generic/Verilog parameter value(s) based on TCL parameter value
	set_property value [get_property value ${PARAM_VALUE.IO_NODE_3_INSTREAMS}] ${MODELPARAM_VALUE.IO_NODE_3_INSTREAMS}
}

proc update_MODELPARAM_VALUE.IO_NODE_3_OUTSTREAMS { MODELPARAM_VALUE.IO_NODE_3_OUTSTREAMS PARAM_VALUE.IO_NODE_3_OUTSTREAMS } {
	# Procedure called to set VHDL generic/Verilog parameter value(s) based on TCL parameter value
	set_property value [get_property value ${PARAM_VALUE.IO_NODE_3_OUTSTREAMS}] ${MODELPARAM_VALUE.IO_NODE_3_OUTSTREAMS}
}

proc update_MODELPARAM_VALUE.IO_NODE_4_INSTREAMS { MODELPARAM_VALUE.IO_NODE_4_INSTREAMS PARAM_VALUE.IO_NODE_4_INSTREAMS } {
	# Procedure called to set VHDL generic/Verilog parameter value(s) based on TCL parameter value
	set_property value [get_property value ${PARAM_VALUE.IO_NODE_4_INSTREAMS}] ${MODELPARAM_VALUE.IO_NODE_4_INSTREAMS}
}

proc update_MODELPARAM_VALUE.IO_NODE_4_OUTSTREAMS { MODELPARAM_VALUE.IO_NODE_4_OUTSTREAMS PARAM_VALUE.IO_NODE_4_OUTSTREAMS } {
	# Procedure called to set VHDL generic/Verilog parameter value(s) based on TCL parameter value
	set_property value [get_property value ${PARAM_VALUE.IO_NODE_4_OUTSTREAMS}] ${MODELPARAM_VALUE.IO_NODE_4_OUTSTREAMS}
}

proc update_MODELPARAM_VALUE.DMA_INTERFACE_TYPE { MODELPARAM_VALUE.DMA_INTERFACE_TYPE PARAM_VALUE.DMA_INTERFACE_TYPE } {
	# Procedure called to set VHDL generic/Verilog parameter value(s) based on TCL parameter value
	set_property value [get_property value ${PARAM_VALUE.DMA_INTERFACE_TYPE}] ${MODELPARAM_VALUE.DMA_INTERFACE_TYPE}
}

proc update_MODELPARAM_VALUE.DMA_AXI_ID_WIDTH { MODELPARAM_VALUE.DMA_AXI_ID_WIDTH PARAM_VALUE.DMA_AXI_ID_WIDTH } {
	# Procedure called to set VHDL generic/Verilog parameter value(s) based on TCL parameter value
	set_property value [get_property value ${PARAM_VALUE.DMA_AXI_ID_WIDTH}] ${MODELPARAM_VALUE.DMA_AXI_ID_WIDTH}
}

proc update_MODELPARAM_VALUE.DMA_ADDR_WIDTH { MODELPARAM_VALUE.DMA_ADDR_WIDTH PARAM_VALUE.DMA_ADDR_WIDTH } {
	# Procedure called to set VHDL generic/Verilog parameter value(s) based on TCL parameter value
	set_property value [get_property value ${PARAM_VALUE.DMA_ADDR_WIDTH}] ${MODELPARAM_VALUE.DMA_ADDR_WIDTH}
}

proc update_MODELPARAM_VALUE.DMA_DATA_WIDTH { MODELPARAM_VALUE.DMA_DATA_WIDTH PARAM_VALUE.DMA_DATA_WIDTH } {
	# Procedure called to set VHDL generic/Verilog parameter value(s) based on TCL parameter value
	set_property value [get_property value ${PARAM_VALUE.DMA_DATA_WIDTH}] ${MODELPARAM_VALUE.DMA_DATA_WIDTH}
}

proc update_MODELPARAM_VALUE.C_IRQ_TYPE { MODELPARAM_VALUE.C_IRQ_TYPE PARAM_VALUE.C_IRQ_TYPE } {
	# Procedure called to set VHDL generic/Verilog parameter value(s) based on TCL parameter value
	set_property value [get_property value ${PARAM_VALUE.C_IRQ_TYPE}] ${MODELPARAM_VALUE.C_IRQ_TYPE}
}

proc update_MODELPARAM_VALUE.DEVICE_ARCHITECTURE { MODELPARAM_VALUE.DEVICE_ARCHITECTURE PARAM_VALUE.DEVICE_ARCHITECTURE } {
	# Procedure called to set VHDL generic/Verilog parameter value(s) based on TCL parameter value
	set_property value [get_property value ${PARAM_VALUE.DEVICE_ARCHITECTURE}] ${MODELPARAM_VALUE.DEVICE_ARCHITECTURE}
}

